/*++++++++++++++
.IDENTIFICATION viz2.js
.LANGUAGE       JavaScript
.AUTHOR         Francois Ochsenbein [CDS]
.ENVIRONMENT    VizieR
.VERSION  1.0   01-May-2001
.VERSION  1.1   12-May-2001: Keep lists of opened windows.
.VERSION  1.2   16-Oct-2001
.VERSION  1.3   12-Apr-2002; VOTable output
.VERSION  1.4   06-Oct-2002: Addition of LAYER (adapted from ADS)
.VERSION  1.5   20-Nov-2002: VOPlot -- PROBLEM IE which UNESCAPES the java!!
.VERSION  1.6   09-Jul-2003: envURLbase envURLhost
.VERSION  1.7   31-Mar-2004: clearFields bug
.VERSION  1.8   02-May-2007: Use a test argument in aW
.VERSION  1.9   21-Oct-2007: GoogleSky + .. (changeOutput modes)
.COMMENTS       All JavaScript Routines used by VizieR
---------------*/

/*===========================================================================
                Definitions
 *===========================================================================*/

  vMozilla=new Number;
  argColors=new String;argColors="";
  orgAction=new String;orgAction="";//orgAction=form.a;
  orgMethod=new String;
  // Keep the List of Windows 
  wName=new Array();  wList = new Array();
  //alert('orgAction=' + orgAction + 'length=' + orgAction.length);
  envVOPlot=new String; envVOPlot="/viz-bin/Echo";
  envURLbase=new String; envURLbase="/viz-bin/";
  envURLhost=new String; envURLhost="";

/*===========================================================================
                Generic JavaScript utilities
 *===========================================================================*/

function ns3el(form, name) {	// For Netscape3 which has no hash array ? 
  var n = form.elements.length;
  var o = form.elements; // Netscape 3 doesn't work with form['-source']
  for (var i=0; i<n; i++) { if (o[i].name == name) return(o[i])}
  // alert('No such element: ' + name); // Apparently, doesn' work...
  return(0)
}

// Clear 1 element in form
function clearField(ob, el) { 
  var o=ob; if (el) o = ob.form[el] ;
  if (o.type == 'text' || o.type == 'hidden') { o.value = ""; return }
  if (o.type == 'checkbox') { o.checked = false ; return }
  if (o.type == 'select-multiple') { o.selectedIndex = -1 ; return }
  if (o.type == 'select-one') { o.selectedIndex = -1 ; return }
  if (o.type == 'reset') return;
  if (o.type == 'button') return;
  if (o.type == 'submit') return;
  alert("Can't clear field: " + o.name) ;
}

// Set a value in Form (hidden or text)
function setValue(ob,name,value){
  var o = ns3el(ob.form, name);
  o.value = value;
}
// Set the vMozilla value
function setMozilla(v) {
  // alert("setMozilla(" + v + ")");
  vMozilla = v
}

// Verify at least one button of a series is pushed
function checkPushed(ob, name) {
  var form = ob.form; var n = form.elements.length; var i = 0 ;
  var o = form.elements; // Netscape 3 doesn't work with form['-source']
  for (var i=0; i<n; i++) {
    if (o[i].name != name) continue;
    if (o[i].type != 'checkbox') continue;
    if (o[i].checked) return(true);
  }
  return(false);
}

// Choose the radio button to set
function setRadio(form, name, value) {
  var n = form.elements.length;  var o = form.elements;  var r = 0;
  for (var i=0; i<n; i++) {
    if (o[i].name == name) { 
      o[i].checked = (o[i].value == value);       
      r += o[i].checked;
    }
  }
  //if (r != 1) alert('Sum of ' + name + ' radio buttons = ' + r);
  return(0)
}

// Set the element in a list
function setOption(o, value) {
  var n = o.options.length;
  var i = 0;
  for (i=0; i<n; i++) {
    if (o.options[i].text.indexOf(value) >= 0) { o.selectedIndex=i; break; }
  }
  if (i>=n) alert('Could not setOption(' + name + ') to ' + value)
  return(0)
}

// Clear elements of form which name starts by a text
// Name equates text when arguments ends with a =
// Special case, if name_start is "*", all non-ASU fields are cleared
function clearFields(ob, name_start) {
  var form = ob.form; if (!form) form = ob;
  var n = form.elements.length; var i ; var text; 
  var cmp = "";		// In case of comparison
  i= name_start.indexOf("=");
  if (i>0) cmp = name_start.substr(0, i);
  for (i = 0 ; i < form.length; i++) {
    text = form.elements[i].name ;
    if (name_start == "*") {
      if ((text.charAt(0) != "-") && (form.elements[i].type == "text"))
	   { clearField(form.elements[i]) }
    } 
    else if (cmp != "") {
	if (cmp == text) clearField(form.elements[i]);
    }
    else {
      if (text.indexOf(name_start) == 0) { clearField(form.elements[i]) }
    }
  }
}

/*===========================================================================
                Popup windows: Help, References, Notes ...
			Window name = aName[_[width_x]height]
 *===========================================================================*/

function full_escape(text) {		// + sometimes NOT converted ???
  var i, tmp;
  tmp = escape(text);
  while (tmp.indexOf('+') >= 0) {
     i = tmp.indexOf('+');
     tmp = tmp.substr(0,i) + "%2b" + tmp.substr(i+1);
  }
  return(tmp);
}

function aW(name,url) {		// Generic Popup Window name_XxY_attr
  var fullURL;
  var n = wName.length ; var wn = name ;
  var tmp, w, i, x, y ;
  var a = 'scrollbars,resizable,toolbar=0,location=0,status=0,menubar=0';
  /* Must compute the fully Qualified URL */
  if (url.indexOf('://') >= 0) { fullURL = url }	// Already complete
  else { if (url.substr(0,1) == '/') { fullURL = envURLhost + url }
  else { fullURL = envURLbase + url }}
  i = fullURL.indexOf('//*&'); 
  if (i>0) {	// Already translated
    // alert("fullURL=" + fullURL);
    tmp = fullURL.substr(i);
    fullURL = fullURL.substr(0,i);
    while (tmp.indexOf('&')>0) {
      i = tmp.indexOf('&');
      fullURL = fullURL + full_escape(tmp.substr(0,i)) + '&';
      tmp = tmp.substr(i+1);
    }
    fullURL = fullURL + full_escape(tmp);
  }
  x = 640; y = 320;			// Default dimensions
  i = name.indexOf('_'); 
  if (i >= 0) { 		// e.g. MyWindow_500x500
      wn = name.substr(0, i);
      tmp = name.substr(i+1);
      i = tmp.indexOf('_') ;	// Maybe attributes ? 
      if (i>=0) { a = tmp.substr(i+1); tmp = tmp.substr(0, i) }
      i = tmp.indexOf('x') ;
      if (i >= 0) { x =  Number(tmp.substr(0, i)); y = Number(tmp.substr(i+1)) }
      else { y = Number(tmp) }
  }
  if (wn == "") { wn = "W" + wName.length; i = n }
  else for (i=0; i<n; i++) { 
      if (wName[i] != wn) continue ;
      w = wList[i]; 
      if (w.closed) w = 0; 
      break ;
  }
  // alert("aw(" + name + ")\ny=" + y + "\nwn=" + wn);
  if (w) {	// Window already exists !
    // alert("Window exists from wn=" + wn + "\nname=" + w.name);
    //*Can't change in Firebird! if ((y > 100) && (y <= 640)) w.innerHeight = y;
    //*Can't change in Firebird! if ((x > 100) && (x <= 640)) w.innerWidth  = x;
    w = window.open(fullURL, wn) ;
  }
  else { 	// New window -- create it 
    tmp= a + ',height=' + y + ',width=' + x ;
    // alert("open " + wn + ": " + tmp) ;
    w = window.open(fullURL, wn, tmp) ;
    wName[i] = wn; wList[i] = w ;
  }
  w.focus();
}

function vHelp(q) {
  var w = aW('wHelp', 'vizHelp?'+argColors+q) ;
}


function vRef(q) {	// Problem IE which unescapes!!!
  var w = aW('wRefs', '/viz-bin/VizieR?-6N&-out.form=H0&'+argColors+q);
}

function Note(catid,notid) {
  var w = aW('wNote', 'VizieR-n?-source=METAnot&catid='+catid+'&notid='+notid
    +'&-out=text') ;
}

function Unit(u) {
  var w = aW('wUnit', '/viz-bin/Unit/w?-n&'+full_escape(u)) ;
}

function UCD(u) {
  var w = aW('wUCD', 'VizieR-n?-source=METAfam&famid='+u) ;
}

function UCD1p(u) {
  var deco = "-6n&-out.form=H0+N&-source=METAucd&-out=name,explain&";
  var cond = "ucdid=" + (u&1023); u >>= 10; u &= 0x3fffff;
  while (u!=0) { cond = cond + "," + (u&1023); u >>= 10; }
  var w = aW("wUCD", "VizieR?" + deco + cond) ;
}

function vNote(q) {
  //alert('VizieR?-6N&-out.form=H0&'+argColors+q);
  var w = aW('wNote', 'VizieR?-6N&-out.form=H0&'+argColors+q) ;
}

/*===========================================================================
                Change the Action to execute
 *===========================================================================*/

// Change action to what's defined by orgAction, and EXECUTE
function setViz() { 
  var form = window.document.forms[0]; 
  if (orgAction.length>0) { form.action = orgAction; form.method = orgMethod; }
  form.submit() ;
}

// Change the Action from what's selected in o = Select Option
function changeOutput(o) {
  if ((o.type != "select-one") && (o.type != "radio")) return ;
  //if (!o.type) o = o[0]; 
  var form = o.form;
  var option_selected = o.options[o.selectedIndex].text ; 
  var a = "";
  // Save the Original Action
  if (orgAction.length == 0) { 
      //alert("Set orgAction=" + a); 
      orgAction = form.action;
      orgMethod = "post";	// That's the default in all cases
  }
  var i = orgAction.lastIndexOf('/'); a = orgAction.substring(0,i+1);

  if (option_selected.indexOf('XML') >= 0) {
    setRadio(form, '-oc.form', 'dec'); 		// Added 2007-10-21
    if (option_selected.indexOf('VOTable') >= 0) {
      a = a + 'votable' ;
      if (option_selected.indexOf('DTD') >= 0) a = a + '/-dtd'; 
      if (option_selected.indexOf('bin') >= 0) a = a + '/-b64'; 
      form.action = a ;
    }
    else {
      form.action = a + 'votable/-csv' ;	// a + 'asu_xml';
    }
  }
  else if(option_selected.indexOf('VOTable') >= 0) {
    setRadio(form, '-oc.form', 'dec'); 		// Added 2007-10-21
    a = a + 'votable' ;
    if (option_selected.indexOf('bin') >= 0) a = a + '/-b64';
    if (option_selected.indexOf('CSV') >= 0) a = a + '/-tsv';
    form.action = a ;
  }

  else if (option_selected.indexOf('SkyC') >= 0) { 
    form.action = a + 'asu-acl';      
    setRadio(form, '-oc.form', 'dec');  
  }
  else if (option_selected.indexOf('VOPlot') >= 0) {
    form.action = envVOPlot;
    form.method = "get";
    setRadio(form, '-oc.form', 'dec');  
  }
  else if (option_selected.indexOf('FIT') >= 0) {
    setRadio(form, '-oc.form', 'dec'); 		// Added 2007-10-21
    form.action = a + 'asu-fits';
  }
  else if (option_selected.indexOf('-Separated-') >= 0) {
    setRadio(form, '-oc.form', 'dec'); 		// Added 2007-10-21
    form.action = a + 'asu-tsv'; 
  }

  // Google sky
  else if ( option_selected.indexOf('KMZ') >=0 ) {
    if (ns3el(form, "-oc.form") == 0)	// Mod. 2007-10-21
      alert("GoogleSky needs coordinates!");
    else {
     	form.action ='kmz4GoogleSky';
	setRadio(form, '-oc.form', 'dec');
    }
  }

  else if (option_selected.indexOf('Echo') >= 0) form.action = a + 'Echo'; 
  else if (form.action.indexOf('VizieR') < 0)  form.action = a + 'VizieR'; 
  else if (orgAction.length>0) {
      form.action = orgAction;
      form.method = orgMethod;
  }
}

// Execute one of the options of the menu
function execOutput(obj, value) {
  var form = obj.form;
  var o = ns3el(form, "-out.form") ;
  setOption(o, value);	// Choose the element in menu
  changeOutput(o);	// Change the action, method
  form.submit();
}

// Change to a GET method (for bookmarking), and EXECUTE
function changeMode() { var form = window.document.forms[0]; 
  // Verify the file is not filled 
  var f = ns3el(form,'-file') ; var c = ns3el(form,'-c') ;
  if (f && c) { 
      if (f.value == '-c' && c.value != "") {
	  alert("No file name can be bookmarked, sorry...") ;
	  return
      }
  }
  text = 'Method: ' + form.method ; 
  form.method = 'get'; // form.encoding = ''; // Problems with IE!!!
  // Be sure we've the original action...
  if (orgAction.length>0) form.action = orgAction;
  var o = ns3el(form,'-this') ; var d = ns3el(form,'-to'); 
  if (o && d) d.value = o.value; d.value += 'b';
  //alert(text + ' ---> ' + form.method); 
  //noText(form);
  form.submit() ;
}

// Submit Only when at least One Box is Checked
function execIfChecked(ob, name, msg){
  var form = ob.form;
  if (checkPushed(ob, name)) form.submit() ;
  else alert(msg);
}

// Submit from a CheckBox, and set the 'to' argument
function execCheck1(ob, phase){
  if (phase>0) setValue(ob, '-to', phase);
  ob.form.submit();
}

// Check the box of the Table/Catalog Button, and Execute
function execSource(ob,ph) { 
  var form = ob.form;
  var val = ob.value; var i=val.indexOf(' '); if(i>0) val=val.substr(0,i);
  var n = form.elements.length; var c = 0 ;
  var allCats = (val.indexOf('search ') >= 0) && (val.indexOf(' catalog') >= 0);
  if (allCats) {
      c = 1;		// This will empty the names of all catalogues.
      ph = "4c";	// This will force searching all catalogues
  }
  var o = form.elements; // Netscape 3 doesn't work with form['-source']
  for (i=0; i<n; i++) { 
    if (o[i].name == '-out') {		// Remove -out (always) if allCats asked
	o[i].checked = false;
	continue;
	//if (!allCats) continue ;
    }
    else if (o[i].name != '-source') continue;
    if (o[i].type == 'checkbox') {o[i].checked = (o[i].value == val); c++}
    else if (o[i].type == 'text' || o[i].type == 'hidden') {
	if (c==0) o[i].value = val; else o[i].value = '';c++;
    }
  }
  if (ph) { 	// Has to execute a specific Phase, e.g. '3' '4'
    o = ns3el(form,'-to'); 
    if (o) { 
      val=ph; 
      if(o.value.length > 1) val = val + o.value.substr(1); o.value = val;
    }
  }
  form.submit() ;
}

/*===========================================================================
                Special Javascript Actions
 *===========================================================================*/

// Check or Reset the 'ALL' boxes 
function allBoxes(all_box, boxes) { 
  var form = all_box.form ;
  var n = form.elements.length; var o = form.elements ;
  var nom = all_box.name ; var i;
  var stat = all_box.checked ;
  var c = form ; if (all_box.name) c = form[all_box.name]; 
  //var text = 'all_box ' + nom + ': ' + n + ' elements.\n'; 
  for (i=0; i<n; i++) { 
    if (o[i].type == 'checkbox' && o[i].name == nom) {
      o[i].checked = stat? stat : o[i].defaultChecked; 
      //text = text + '\n' + o[i].name + '=' + o[i].value       + ': ' 
      //     + o[i].checked
    }
  }
  if (boxes) {
    nom = boxes ; 
    for (i=0; i<n; i++) {
      if (o[i].type == 'checkbox' && o[i].name == nom){
	o[i].checked = stat? stat : o[i].defaultChecked; 
        //text = text + '\n' + o[i].name + '=' + o[i].value         + ': ' 
	//     + o[i].checked
      }
    }
  }
  //alert(text);
}

// The Form Adaptation
function execAdapt(name, val, msg) { 
  if (msg) { alert(msg); return }
  var form = window.document.forms[0] ;
  var field=ns3el(form, name); var a = form.action ;
  var i = a.lastIndexOf('/'); a = a.substring(0,i+1);
  form.action = a + 'VizieR'; // Only HTML presentation of AdaptForm!
  field.name = '!-3;' + field.name + '=' + val + ';//'; 
  if ((name == '-file') && (val != '.')) form.action = form.action + '#aLIST';
  form.submit();
}

/*===========================================================================
                LAYER additions
 *===========================================================================*/

//var vers = navigator.appVersion;
var nver = navigator.appVersion.substring(0,4);
var isNS = (navigator.appName.indexOf("Netscape") !=-1);
var x,y;
var laycolor = "#ffffe0";	// Default = LightYellow
// Change the layer color
function set_laycolor(color) { laycolor = color }
// Addition of text in a layer
function lay(text){
  var t = "<table border='1' cellpadding='3' cellspacing='0' bgcolor='" + 
       laycolor + "'>" + "<tr><td>";
  t = t + text.replace(/&apos;/g, "'");
  t = t + "</td></tr></table>";
  if ((isNS) && (nver<5)) {
    df = document.xplain;
    df.document.write(t);
    df.document.close();
    df.left=x-50;
    df.top =y+10; //document.xplain.top=y+10;
  } else {
    df = document.getElementById('xplain');
    df.innerHTML=t;
    df.style.background=laycolor; // "rgb(255,255,224)"
    df.style.left=x-50;
    df.style.top=y+10;
  }
}
function laz(){	// Out of layer
  if ((isNS) && (nver<5)) { document.xplain.top=-50; }
  else {
    df = document.getElementById('xplain');
    df.innerHTML="";
  }
}
function handlerMM(e){
  x = (isNS) ? e.pageX : event.clientX + document.body.scrollLeft;
  y = (isNS) ? e.pageY : event.clientY + document.body.scrollTop;
}
if (isNS&&(nver<5)){ document.captureEvents(Event.MOUSEMOVE); }
// Install the event handler
document.onmousemove = handlerMM;
if((isNS)&&(nver<5)) {
document.write("<LAYER name=\"xplain\" visibility=\"show\" left=\"25\" top=\"-50\" z-index=\"99\"><br></LAYER>") ;
} else {
document.write("<DIV ID=\"xplain\" style=\"position:absolute; visibility:show; left:25px; top:-50px; z-index:2\"><br></DIV>") ;
}

function add_biblink2(idb){
  alert("manage simbad link  new");
  var b=document.getElementById(idb);
  if( !b ) { alert("biblink info are not found!!"); return; }
  
  var l=document.getElementsByName('-out.add');
  
  if( b.checked==false ){
      for(var i=0;i<l.length;i++){
        if( l[i].getAttribute('value')=='_RA*-c.eq,_DE*-c.eq,_b' ) {
            if( l[i].getAttribute("type")=='hidden' )
                l[i].parentNode.removeChild(l[i]);
            alert("remove link");
        }
        if( l[i].getAttribute('value')=='_RA*-c.eq,_DE*-c.eq') 
            l[i].checked=true;
      }
  }
  else{
      for(var i=0;i<l.length;i++){
        if( l[i].getAttribute('value')=='_RA*-c.eq,_DE*-c.eq') {
            alert("type="+ l[i].getAttribute("type"));

            if( l[i].getAttribute("type")=='hidden' )
                l[i].parentNode.removeChild(l[i]);
            else if(  l[i].getAttribute("type")=='checkbox' )
                l[i].checked=false;
            alert("remove coordinates");
        }
      }
  }
}

function add_biblink(id){
  var b=document.getElementById(id);
  if( !b ) { alert("biblink info are not found!!"); return; }
  
  var l=document.getElementsByName('-out.add');
  if( b.checked==false ){
      for(var i=0;i<l.length;i++){
        if( l[i].getAttribute('value')=='_RA*-c.eq,_DE*-c.eq,_b' ) {
            l[i].setAttribute('value', '_RA*-c.eq,_DE*-c.eq');
        }
      }
  }
  else{
      var elt=false; 
      for(var i=0;i<l.length;i++){
        if( l[i].getAttribute('value')=='_RA*-c.eq,_DE*-c.eq') {
            l[i].setAttribute('value', '_RA*-c.eq,_DE*-c.eq,_b');
            if( l[i].getAttribute('type')=="checkbox" ) { elt=l[i].checked; }
            else elt=true;
        }
        else if( l[i].getAttribute('value')=='_RA*-c.eq,_DE*-c.eq,_b') {
            elt=true;
        }
      }
      if( elt==false ){
        alert("add position _RAJ,_DEJ");
        b.setAttribute('name', '-out.add');
        b.setAttribute('value', '_RA*-c.eq,_DE*-c.eq,_b');
      }
  }
}

//==============================================================================
