# galaxy_clusters.dsc
#
# Extended galaxy cluster Deep Space Catalog for Celestia v1.3
#
# Version 1.01 
#  - converted to .DSC format for Celestia v1.3 by s.ball 24feb03 
#  - deleted globular clusters (now in a separate file)
#  - deleted local galaxies that are included with Celestia
#  - deleted galaxies that are listed in galaxies.dsc
#
# Version 1.00b (b denotes version with galaxy clusters)
#  - Added version number
#  - Added galaxies out to NGC 4151
#  - Added Messier designations to globular clusters
# 
# An extension of the original galaxies.dat
# Modified by Paul Baulch (pbaulch@au.infogrames.com)
# Modified by s.ball (seb+cel@lns.cornell.edu) 24feb03
#
# What to do with this file as of v1.01:
# 1) Copy this file to Celestia/extras/ or your personal extras directory
# 2) Run Celestia, and you should see the rest of the Universe!
#
# Contents as of v1.01:
#
#  819 galaxy clusters
#############################################################################
#
# Galaxy clusters, rendered as galaxies
# These really need their own shader so they don't look like big bright blobs.
#
# Taken from 'Rich Clusters of Galaxies' (Abell+ 1989)
#
# Notes:
#
# Only clusters with redshifts have been included.
# 'Abell' denotes an entry that had a redshift in the original Abell catalogue.
# 'ACOS' denotes a member of the southern hemisphere survey.
#
# Due to lack of data, Cluster radii have been 'made up', on the assumption that the
# density of galaxies across all clusters is constant, and that for an Abell catalogue
# entry, each galaxy contributing to the 'count' field occupies 1 cubic Mly. Total volume
# for the cluster can therefore give the radius by V = 4 * pi * r^3.
#
# Distances were calculated from redshifts using the following formulas:
#
# Rvel = c * ((1+z)^2-1) / ((1+z)^2+1)
# dist = Rvel * 3.26 / H0  (H0 = 75km/s/Mpc, Hubble Constant)
#

# ACOS 373 is currently more well represented by individual galaxies.
#"AS373"
#{
#	AbsMag  -10.0  	Type "E0"
#	RA 3.642
#	Dec -35.45
#	Distance 6.0e7
#	Radius 9.26e5
#}

Galaxy "#AS636"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS636"
	AbsMag  -10.0  	Type "E0"
	RA 10.5
	Dec -35.32
	Distance 1.13e8
	Radius 1.29e6
}

Galaxy "#AS851"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS851"
	AbsMag  -10.0  	Type "E0"
	RA 20.165
	Dec -48.39
	Distance 1.30e8
	Radius 2.34e6
}

Galaxy "#A3560"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3560"
	AbsMag  -10.0  	Type "E0"
	RA 13.531
	Dec -33.22
	Distance 1.41e8
	Radius 7.32e6
}

Galaxy "#A3565"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3565"
	AbsMag  -10.0  	Type "E0"
	RA 13.611
	Dec -33.97
	Distance 1.41e8
	Radius 5.15e6
}

Galaxy "#A3526"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3526"
	AbsMag  -10.0  	Type "E0"
	RA 12.815
	Dec -41.31
	Distance 1.43e8
	Radius 4.13e6
}

Galaxy "#Abell 1060"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 1060"
	AbsMag  -10.0  	Type "E0"
	RA 10.614
	Dec -27.53
	Distance 1.48e8
	Radius 4.75e6
}

Galaxy "#AS805"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS805"
	AbsMag  -10.0  	Type "E0"
	RA 18.787
	Dec -63.33
	Distance 1.80e8
	Radius 2.58e6
}

Galaxy "#AS574"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS574"
	AbsMag  -10.0  	Type "E0"
	RA 6.21
	Dec -45.08
	Distance 1.81e8
	Radius 3.44e6
}

Galaxy "#AS753"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS753"
	AbsMag  -10.0  	Type "E0"
	RA 14.061
	Dec -33.97
	Distance 1.81e8
	Radius 3.38e6
}


Galaxy "#A3574"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3574"
	AbsMag  -10.0  	Type "E0"
	RA 13.819
	Dec -30.3
	Distance 1.83e8
	Radius 4.05e6
}


Galaxy "#A3627"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3627"
	AbsMag  -10.0  	Type "E0"
	RA 16.259
	Dec -60.91
	Distance 1.85e8
	Radius 5.02e6
}

Galaxy "#AS521"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS521"
	AbsMag  -10.0  	Type "E0"
	RA 5.317
	Dec -37.1
	Distance 1.94e8
	Radius 9.26e5
}


Galaxy "#AS840"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS840"
	AbsMag  -10.0  	Type "E0"
	RA 20.057
	Dec -55.96
	Distance 1.97e8
	Radius 3.18e6
}


Galaxy "#A3554"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3554"
	AbsMag  -10.0  	Type "E0"
	RA 13.325
	Dec -33.48
	Distance 1.98e8
	Radius 5.02e6
}


Galaxy "#A262"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A262"
	AbsMag  -10.0  	Type "E0"
	RA 1.881
	Dec 36.15
	Distance 2.08e8
	Radius 4.41e6
}


Galaxy "#A3742"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3742"
	AbsMag  -10.0  	Type "E0"
	RA 21.111
	Dec -47.15
	Distance 2.13e8
	Radius 4.21e6
}

Galaxy "#A3537"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3537"
	AbsMag  -10.0  	Type "E0"
	RA 13.017
	Dec -32.44
	Distance 2.16e8
	Radius 4.21e6
}

Galaxy "#AS182"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS182"
	AbsMag  -10.0  	Type "E0"
	RA 1.723
	Dec -36.37
	Distance 2.26e8
	Radius 2.2e6
}

Galaxy "#A194"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A194"
	AbsMag  -10.0  	Type "E0"
	RA 1.426
	Dec -1.51
	Distance 2.3e8
	Radius 4.3e6
}

Galaxy "#A426"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A426"
	AbsMag  -10.0  	Type "E0"
	RA 3.31
	Dec 41.52
	Distance 2.36e8
	Radius 5.73e6
}

Galaxy "#AS866"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS866"
	AbsMag  -10.0  	Type "E0"
	RA 20.364
	Dec -49.71
	Distance 2.36e8
	Radius 9.27e5
}

Galaxy "#A3656"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3656"
	AbsMag  -10.0  	Type "E0"
	RA 20.009
	Dec -38.53
	Distance 2.39e8
	Radius 4.21e6
}

Galaxy "#A347"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A347"
	AbsMag  -10.0  	Type "E0"
	RA 2.431
	Dec 41.87
	Distance 2.41e8
	Radius 4.09e6
}

Galaxy "#AS500"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS500"
	AbsMag  -10.0  	Type "E0"
	RA 4.779
	Dec -62.46
	Distance 2.45e8
	Radius 9.27e5
}

Galaxy "#A569"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A569"
	AbsMag  -10.0  	Type "E0"
	RA 7.153
	Dec 48.62
	Distance 2.53e8
	Radius 4.25e6
}

Galaxy "#AS85"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS85"
	AbsMag  -10.0  	Type "E0"
	RA 0.832
	Dec -47.38
	Distance 2.53e8
	Radius 9.27e5
}

Galaxy "#A3706"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3706"
	AbsMag  -10.0  	Type "E0"
	RA 20.704
	Dec -38.34
	Distance 2.58e8
	Radius 4.44e6
}

Galaxy "#AS316"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS316"
	AbsMag  -10.0  	Type "E0"
	RA 3.005
	Dec -37.04
	Distance 2.59e8
	Radius 2.34e6
}

Galaxy "#A2911"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2911"
	AbsMag  -10.0  	Type "E0"
	RA 1.434
	Dec -37.97
	Distance 2.61e8
	Radius 5.36e6
}

Galaxy "#AS639"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS639"
	AbsMag  -10.0  	Type "E0"
	RA 10.676
	Dec -46.19
	Distance 2.63e8
	Radius 3.11e6
}

Galaxy "#A539"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A539"
	AbsMag  -10.0  	Type "E0"
	RA 5.277
	Dec 6.45
	Distance 2.64e8
	Radius 4.75e6
}

Galaxy "#AS141"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS141"
	AbsMag  -10.0  	Type "E0"
	RA 1.229
	Dec -31.75
	Distance 2.66e8
	Radius 2.95e6
}

Galaxy "#A2933"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2933"
	AbsMag  -10.0  	Type "E0"
	RA 1.678
	Dec -54.56
	Distance 2.68e8
	Radius 5.48e6
}

Galaxy "#AS283"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS283"
	AbsMag  -10.0  	Type "E0"
	RA 2.592
	Dec -50.32
	Distance 2.73e8
	Radius 2.68e6
}

Galaxy "#A1367"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1367"
	AbsMag  -10.0  	Type "E0"
	RA 11.741
	Dec 19.84
	Distance 2.77e8
	Radius 6.3e6
}

Galaxy "#AS301"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS301"
	AbsMag  -10.0  	Type "E0"
	RA 2.827
	Dec -31.19
	Distance 2.87e8
	Radius 2.2e6
}

Galaxy "#A3879"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3879"
	AbsMag  -10.0  	Type "E0"
	RA 22.464
	Dec -69.03
	Distance 2.89e8
	Radius 6.25e6
}

Galaxy "#AS897"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS897"
	AbsMag  -10.0  	Type "E0"
	RA 20.791
	Dec -38.42
	Distance 2.89e8
	Radius 3.77e6
}

Galaxy "#A400"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A400"
	AbsMag  -10.0  	Type "E0"
	RA 2.961
	Dec 6.03
	Distance 2.99e8
	Radius 4.99e6
}

Galaxy "#A1656"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1656"
	AbsMag  -10.0  	Type "E0"
	RA 13.0
	Dec 27.98
	Distance 2.99e8
	Radius 6.1e6
}

Galaxy "#AS778"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS778"
	AbsMag  -10.0  	Type "E0"
	RA 14.941
	Dec -37.6
	Distance 3.05e8
	Radius 2.05e6
}

Galaxy "#A2877"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2877"
	AbsMag  -10.0  	Type "E0"
	RA 1.164
	Dec -45.9
	Distance 3.1e8
	Radius 4.0e6
}

Galaxy "#AS45"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS45"
	AbsMag  -10.0  	Type "E0"
	RA 0.428
	Dec -56.97
	Distance 3.1e8
	Radius 3.5e6
}

Galaxy "#AS900"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS900"
	AbsMag  -10.0  	Type "E0"
	RA 20.812
	Dec -38.0
	Distance 3.13e8
	Radius 2.95e6
}

#A3389 / AS585
Galaxy "#A3389:AS585"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3389"
	AbsMag  -10.0  	Type "E0"
	RA 6.363
	Dec -64.96
	Distance 3.19e8
	Radius 4.21e6
}

Galaxy "#A2870"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2870"
	AbsMag  -10.0  	Type "E0"
	RA 1.129
	Dec -46.92
	Distance 3.21e8
	Radius 4.13e6
}

Galaxy "#AS892"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS892"
	AbsMag  -10.0  	Type "E0"
	RA 20.695
	Dec -37.65
	Distance 3.27e8
	Radius 3.25e6
}

Galaxy "#AS137"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS137"
	AbsMag  -10.0  	Type "E0"
	RA 1.197
	Dec -61.53
	Distance 3.38e8
	Radius 9.27e5
}

Galaxy "#AS311"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS311"
	AbsMag  -10.0  	Type "E0"
	RA 2.907
	Dec -66.41
	Distance 3.38e8
	Radius 3.18e6
}

Galaxy "#A2666"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2666"
	AbsMag  -10.0  	Type "E0"
	RA 23.849
	Dec 27.14
	Distance 3.41e8
	Radius 4.17e6
}

Galaxy "#A634"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A634"
	AbsMag  -10.0  	Type "E0"
	RA 8.243
	Dec 58.05
	Distance 3.43e8
	Radius 4.41e6
}

Galaxy "#A2860"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2860"
	AbsMag  -10.0  	Type "E0"
	RA 1.069
	Dec -39.78
	Distance 3.45e8
	Radius 4.44e6
}

Galaxy "#AS6"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS6"
	AbsMag  -10.0  	Type "E0"
	RA 0.079
	Dec -30.49
	Distance 3.47e8
	Radius 2.47e6
}

Galaxy "#A2806"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2806"
	AbsMag  -10.0  	Type "E0"
	RA 0.669
	Dec -56.16
	Distance 3.48e8
	Radius 4.29e6
}

Galaxy "#AS754"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS754"
	AbsMag  -10.0  	Type "E0"
	RA 14.106
	Dec -39.82
	Distance 3.61e8
	Radius 9.27e5
}

Galaxy "#A3381"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3381"
	AbsMag  -10.0  	Type "E0"
	RA 6.165
	Dec -33.59
	Distance 3.62e8
	Radius 5.28e6
}

Galaxy "#AS898"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS898"
	AbsMag  -10.0  	Type "E0"
	RA 20.791
	Dec -30.17
	Distance 3.62e8
	Radius 1.86e6
}

Galaxy "#A4038"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A4038"
	AbsMag  -10.0  	Type "E0"
	RA 23.795
	Dec -28.14
	Distance 3.64e8
	Radius 6.3e6
}

Galaxy "#A4049"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A4049"
	AbsMag  -10.0  	Type "E0"
	RA 23.86
	Dec -28.37
	Distance 3.64e8
	Radius 4.37e6
}

Galaxy "#AS74"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS74"
	AbsMag  -10.0  	Type "E0"
	RA 0.762
	Dec -49.94
	Distance 3.64e8
	Radius 3.56e6
}

Galaxy "#A3990"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3990"
	AbsMag  -10.0  	Type "E0"
	RA 23.313
	Dec -67.78
	Distance 3.67e8
	Radius 5.94e6
}

Galaxy "#AS1065"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1065"
	AbsMag  -10.0  	Type "E0"
	RA 22.822
	Dec -37.49
	Distance 3.7e8
	Radius 9.27e5
}

Galaxy "#AS882"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS882"
	AbsMag  -10.0  	Type "E0"
	RA 20.591
	Dec -43.44
	Distance 3.73e8
	Radius 9.27e5
}

Galaxy "#AS921"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS921"
	AbsMag  -10.0  	Type "E0"
	RA 21.114
	Dec -44.83
	Distance 3.73e8
	Radius 3.87e6
}

Galaxy "#AS1165"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1165"
	AbsMag  -10.0  	Type "E0"
	RA 23.978
	Dec -29.85
	Distance 3.84e8
	Radius 1.86e6
}

Galaxy "#A2197"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2197"
	AbsMag  -10.0  	Type "E0"
	RA 16.469
	Dec 40.91
	Distance 3.89e8
	Radius 5.38e6
}

Galaxy "#A2199"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2199"
	AbsMag  -10.0  	Type "E0"
	RA 16.477
	Dec 39.52
	Distance 3.89e8
	Radius 5.73e6
}

Galaxy "#A1185"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1185"
	AbsMag  -10.0  	Type "E0"
	RA 11.18
	Dec 28.68
	Distance 3.9e8
	Radius 4.81e6
}

Galaxy "#A3747"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3747"
	AbsMag  -10.0  	Type "E0"
	RA 21.145
	Dec -43.5
	Distance 3.93e8
	Radius 4.55e6
}

Galaxy "#AS922"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS922"
	AbsMag  -10.0  	Type "E0"
	RA 21.115
	Dec -39.65
	Distance 3.93e8
	Radius 3.72e6
}

Galaxy "#AS274"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS274"
	AbsMag  -10.0  	Type "E0"
	RA 2.519
	Dec -57.93
	Distance 3.97e8
	Radius 9.27e5
}

Galaxy "#A2634"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2634"
	AbsMag  -10.0  	Type "E0"
	RA 23.639
	Dec 27.03
	Distance 4.0e8
	Radius 4.81e6
}

Galaxy "#A2731"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2731"
	AbsMag  -10.0  	Type "E0"
	RA 0.17
	Dec -56.99
	Distance 4.0e8
	Radius 4.37e6
}

Galaxy "#AS743"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS743"
	AbsMag  -10.0  	Type "E0"
	RA 13.771
	Dec -39.9
	Distance 4.04e8
	Radius 9.27e5
}

Galaxy "#A1177"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1177"
	AbsMag  -10.0  	Type "E0"
	RA 11.158
	Dec 21.7
	Distance 4.05e8
	Radius 4.09e6
}

Galaxy "#AS109"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS109"
	AbsMag  -10.0  	Type "E0"
	RA 0.955
	Dec -30.93
	Distance 4.05e8
	Radius 9.27e5
}

Galaxy "#A2896"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2896"
	AbsMag  -10.0  	Type "E0"
	RA 1.305
	Dec -37.1
	Distance 4.07e8
	Radius 4.55e6
}

Galaxy "#A999"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A999"
	AbsMag  -10.0  	Type "E0"
	RA 10.389
	Dec 12.85
	Distance 4.08e8
	Radius 4.13e6
}

Galaxy "#AS665"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS665"
	AbsMag  -10.0  	Type "E0"
	RA 11.431
	Dec -35.39
	Distance 4.08e8
	Radius 2.95e6
}

Galaxy "#A496"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A496"
	AbsMag  -10.0  	Type "E0"
	RA 4.56
	Dec -13.25
	Distance 4.1e8
	Radius 4.75e6
}

Galaxy "#A2162"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2162"
	AbsMag  -10.0  	Type "E0"
	RA 16.208
	Dec 29.54
	Distance 4.1e8
	Radius 4.29e6
}

Galaxy "#A3749"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3749"
	AbsMag  -10.0  	Type "E0"
	RA 21.171
	Dec -45.81
	Distance 4.1e8
	Radius 4.9e6
}

Galaxy "#A1016"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1016"
	AbsMag  -10.0  	Type "E0"
	RA 10.451
	Dec 10.98
	Distance 4.12e8
	Radius 4.29e6
}

Galaxy "#A1267"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1267"
	AbsMag  -10.0  	Type "E0"
	RA 11.466
	Dec 26.86
	Distance 4.12e8
	Radius 4.29e6
}

Galaxy "#AS112"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS112"
	AbsMag  -10.0  	Type "E0"
	RA 0.973
	Dec -66.81
	Distance 4.12e8
	Radius 3.25e6
}

Galaxy "#AS1055"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1055"
	AbsMag  -10.0  	Type "E0"
	RA 22.721
	Dec -39.87
	Distance 4.13e8
	Radius 9.27e5
}

Galaxy "#AS971"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS971"
	AbsMag  -10.0  	Type "E0"
	RA 21.77
	Dec -46.52
	Distance 4.16e8
	Radius 9.27e5
}

Galaxy "#A397"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A397"
	AbsMag  -10.0  	Type "E0"
	RA 2.95
	Dec 15.95
	Distance 4.17e8
	Radius 4.21e6
}

Galaxy "#AS497"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS497"
	AbsMag  -10.0  	Type "E0"
	RA 4.769
	Dec -44.73
	Distance 4.22e8
	Radius 9.27e5
}

Galaxy "#A3677"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3677"
	AbsMag  -10.0  	Type "E0"
	RA 20.439
	Dec -33.35
	Distance 4.23e8
	Radius 5.04e6
}

Galaxy "#A2506"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2506"
	AbsMag  -10.0  	Type "E0"
	RA 22.943
	Dec 13.33
	Distance 4.24e8
	Radius 5.46e6
}

Galaxy "#AS1060"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1060"
	AbsMag  -10.0  	Type "E0"
	RA 22.779
	Dec -46.02
	Distance 4.24e8
	Radius 3.61e6
}

Galaxy "#A189"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A189"
	AbsMag  -10.0  	Type "E0"
	RA 1.395
	Dec 1.64
	Distance 4.29e8
	Radius 4.75e6
}

Galaxy "#AS740"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS740"
	AbsMag  -10.0  	Type "E0"
	RA 13.725
	Dec -38.18
	Distance 4.31e8
	Radius 1.62e6
}

Galaxy "#A2063"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2063"
	AbsMag  -10.0  	Type "E0"
	RA 15.384
	Dec 8.64
	Distance 4.32e8
	Radius 5.13e6
}

Galaxy "#A1257"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1257"
	AbsMag  -10.0  	Type "E0"
	RA 11.435
	Dec 35.32
	Distance 4.34e8
	Radius 4.48e6
}

Galaxy "#A3193"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3193"
	AbsMag  -10.0  	Type "E0"
	RA 3.97
	Dec -52.34
	Distance 4.36e8
	Radius 4.44e6
}

Galaxy "#A1314"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1314"
	AbsMag  -10.0  	Type "E0"
	RA 11.58
	Dec 49.04
	Distance 4.37e8
	Radius 4.55e6
}

Galaxy "#AS1106"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1106"
	AbsMag  -10.0  	Type "E0"
	RA 23.291
	Dec -42.84
	Distance 4.43e8
	Radius 9.27e5
}

Galaxy "#AS981"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS981"
	AbsMag  -10.0  	Type "E0"
	RA 21.929
	Dec -55.58
	Distance 4.44e8
	Radius 3.56e6
}

Galaxy "#A260"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A260"
	AbsMag  -10.0  	Type "E0"
	RA 1.865
	Dec 33.16
	Distance 4.46e8
	Radius 4.78e6
}

Galaxy "#A2052"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2052"
	AbsMag  -10.0  	Type "E0"
	RA 15.279
	Dec 7.0
	Distance 4.46e8
	Radius 4.44e6
}

Galaxy "#A1228"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1228"
	AbsMag  -10.0  	Type "E0"
	RA 11.358
	Dec 34.33
	Distance 4.48e8
	Radius 4.75e6
}

Galaxy "#Abell 1736"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 1736"
	AbsMag  -10.0  	Type "E0"
	RA 13.451
	Dec -27.16
	Distance 4.48e8
	Radius 6.06e6
}

Galaxy "#A3816"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3816"
	AbsMag  -10.0  	Type "E0"
	RA 21.841
	Dec -55.32
	Distance 4.51e8
	Radius 4.37e6
}

Galaxy "#A1142"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1142"
	AbsMag  -10.0  	Type "E0"
	RA 11.015
	Dec 10.55
	Distance 4.52e8
	Radius 4.21e6
}

Galaxy "#AS1020"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1020"
	AbsMag  -10.0  	Type "E0"
	RA 22.404
	Dec -56.48
	Distance 4.55e8
	Radius 3.77e6
}

Galaxy "#A2147"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2147"
	AbsMag  -10.0  	Type "E0"
	RA 16.038
	Dec 15.9
	Distance 4.56e8
	Radius 4.81e6
}

Galaxy "#AS540"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS540"
	AbsMag  -10.0  	Type "E0"
	RA 5.669
	Dec -40.84
	Distance 4.58e8
	Radius 3.61e6
}

Galaxy "#AS1129"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1129"
	AbsMag  -10.0  	Type "E0"
	RA 23.497
	Dec -31.11
	Distance 4.58e8
	Radius 1.86e6
}

Galaxy "#A1836"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1836"
	AbsMag  -10.0  	Type "E0"
	RA 14.028
	Dec -11.61
	Distance 4.65e8
	Radius 4.44e6
}

Galaxy "#AS479"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS479"
	AbsMag  -10.0  	Type "E0"
	RA 4.629
	Dec -51.43
	Distance 4.65e8
	Radius 9.27e5
}

Galaxy "#AS989"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS989"
	AbsMag  -10.0  	Type "E0"
	RA 22.073
	Dec -50.07
	Distance 4.65e8
	Radius 3.77e6
}

Galaxy "#AS404"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS404"
	AbsMag  -10.0  	Type "E0"
	RA 3.939
	Dec -53.87
	Distance 4.67e8
	Radius 3.66e6
}

Galaxy "#A3664"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3664"
	AbsMag  -10.0  	Type "E0"
	RA 20.233
	Dec -80.65
	Distance 4.72e8
	Radius 5.15e6
}

Galaxy "#AS413"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS413"
	AbsMag  -10.0  	Type "E0"
	RA 4.045
	Dec -63.8
	Distance 4.73e8
	Radius 9.27e5
}

Galaxy "#A2151"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2151"
	AbsMag  -10.0  	Type "E0"
	RA 16.087
	Dec 17.75
	Distance 4.75e8
	Radius 5.71e6
}

Galaxy "#AS873"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS873"
	AbsMag  -10.0  	Type "E0"
	RA 20.431
	Dec -33.55
	Distance 4.75e8
	Radius 9.27e5
}

Galaxy "#A3570"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3570"
	AbsMag  -10.0  	Type "E0"
	RA 13.781
	Dec -37.92
	Distance 4.76e8
	Radius 4.05e6
}

Galaxy "#AS487"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS487"
	AbsMag  -10.0  	Type "E0"
	RA 4.674
	Dec -44.64
	Distance 4.76e8
	Radius 9.27e5
}

Galaxy "#A2152"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2152"
	AbsMag  -10.0  	Type "E0"
	RA 16.089
	Dec 16.45
	Distance 4.78e8
	Radius 5.04e6
}

Galaxy "#A1837"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1837"
	AbsMag  -10.0  	Type "E0"
	RA 14.029
	Dec -11.16
	Distance 4.81e8
	Radius 4.75e6
}

Galaxy "#A2995"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2995"
	AbsMag  -10.0  	Type "E0"
	RA 2.253
	Dec -24.83
	Distance 4.83e8
	Radius 5.28e6
}

Galaxy "#AS411"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS411"
	AbsMag  -10.0  	Type "E0"
	RA 4.013
	Dec -64.98
	Distance 4.86e8
	Radius 9.27e5
}

Galaxy "#A576"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A576"
	AbsMag  -10.0  	Type "E0"
	RA 7.357
	Dec 55.74
	Distance 4.87e8
	Radius 5.07e6
}

Galaxy "#A3911"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3911"
	AbsMag  -10.0  	Type "E0"
	RA 22.769
	Dec -52.72
	Distance 4.87e8
	Radius 4.99e6
}

Galaxy "#A1139"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1139"
	AbsMag  -10.0  	Type "E0"
	RA 10.968
	Dec 1.5
	Distance 4.9e8
	Radius 4.25e6
}

Galaxy "#AS338"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS338"
	AbsMag  -10.0  	Type "E0"
	RA 3.303
	Dec -52.25
	Distance 4.91e8
	Radius 9.27e5
}

Galaxy "#A3545"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3545"
	AbsMag  -10.0  	Type "E0"
	RA 13.19
	Dec -34.08
	Distance 4.92e8
	Radius 4.37e6
}

Galaxy "#A484"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A484"
	AbsMag  -10.0  	Type "E0"
	RA 4.272
	Dec -7.66
	Distance 4.93e8
	Radius 4.75e6
}

Galaxy "#A3733"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3733"
	AbsMag  -10.0  	Type "E0"
	RA 21.033
	Dec -28.05
	Distance 4.93e8
	Radius 5.02e6
}

Galaxy "#A3202"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3202"
	AbsMag  -10.0  	Type "E0"
	RA 4.004
	Dec -53.66
	Distance 4.96e8
	Radius 5.18e6
}

Galaxy "#A2247"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2247"
	AbsMag  -10.0  	Type "E0"
	RA 16.789
	Dec 81.57
	Distance 5.01e8
	Radius 4.21e6
}

Galaxy "#AS399"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS399"
	AbsMag  -10.0  	Type "E0"
	RA 3.908
	Dec -53.8
	Distance 5.03e8
	Radius 2.87e6
}

Galaxy "#AS463"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS463"
	AbsMag  -10.0  	Type "E0"
	RA 4.486
	Dec -53.83
	Distance 5.03e8
	Radius 3.82e6
}

Galaxy "#A2572"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2572"
	AbsMag  -10.0  	Type "E0"
	RA 23.307
	Dec 18.74
	Distance 5.05e8
	Radius 4.09e6
}

Galaxy "#AS5"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS5"
	AbsMag  -10.0  	Type "E0"
	RA 0.077
	Dec -45.62
	Distance 5.05e8
	Radius 9.27e5
}

Galaxy "#A3869"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3869"
	AbsMag  -10.0  	Type "E0"
	RA 22.357
	Dec -55.13
	Distance 5.06e8
	Radius 4.71e6
}

Galaxy "#AS549"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS549"
	AbsMag  -10.0  	Type "E0"
	RA 5.844
	Dec -32.27
	Distance 5.15e8
	Radius 9.27e5
}

Galaxy "#A3676"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3676"
	AbsMag  -10.0  	Type "E0"
	RA 20.422
	Dec -40.35
	Distance 5.16e8
	Radius 4.13e6
}

Galaxy "#AS569"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS569"
	AbsMag  -10.0  	Type "E0"
	RA 6.161
	Dec -47.63
	Distance 5.17e8
	Radius 9.27e5
}

Galaxy "#AS844"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS844"
	AbsMag  -10.0  	Type "E0"
	RA 20.124
	Dec -53.14
	Distance 5.17e8
	Radius 3.11e6
}

Galaxy "#AS988"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS988"
	AbsMag  -10.0  	Type "E0"
	RA 22.076
	Dec -58.12
	Distance 5.17e8
	Radius 3.25e6
}

Galaxy "#Abell 419"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 419"
	AbsMag  -10.0  	Type "E0"
	RA 3.137
	Dec -23.69
	Distance 5.19e8
	Radius 3.91e6
}

Galaxy "#AS894"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS894"
	AbsMag  -10.0  	Type "E0"
	RA 20.727
	Dec -26.42
	Distance 5.22e8
	Radius 2.2e6
}

Galaxy "#AS353"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS353"
	AbsMag  -10.0  	Type "E0"
	RA 3.439
	Dec -51.41
	Distance 5.24e8
	Radius 9.27e5
}

Galaxy "#Abell 548"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 548"
	AbsMag  -10.0  	Type "E0"
	RA 5.782
	Dec -25.63
	Distance 5.24e8
	Radius 5.81e6
}

Galaxy "#A2657"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2657"
	AbsMag  -10.0  	Type "E0"
	RA 23.747
	Dec 9.14
	Distance 5.29e8
	Radius 4.78e6
}

Galaxy "#A76"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A76"
	AbsMag  -10.0  	Type "E0"
	RA 0.663
	Dec 6.77
	Distance 5.31e8
	Radius 4.48e6
}

Galaxy "#AS63"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS63"
	AbsMag  -10.0  	Type "E0"
	RA 0.597
	Dec -52.19
	Distance 5.32e8
	Radius 9.27e5
}

Galaxy "#A688"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A688"
	AbsMag  -10.0  	Type "E0"
	RA 8.625
	Dec 15.86
	Distance 5.37e8
	Radius 4.75e6
}

Galaxy "#A2107"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2107"
	AbsMag  -10.0  	Type "E0"
	RA 15.663
	Dec 21.77
	Distance 5.37e8
	Radius 4.78e6
}

Galaxy "#A2589"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2589"
	AbsMag  -10.0  	Type "E0"
	RA 23.4
	Dec 16.82
	Distance 5.37e8
	Radius 4.41e6
}

Galaxy "#A195"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A195"
	AbsMag  -10.0  	Type "E0"
	RA 1.449
	Dec 19.18
	Distance 5.39e8
	Radius 4.09e6
}

Galaxy "#A3144"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3144"
	AbsMag  -10.0  	Type "E0"
	RA 3.618
	Dec -55.02
	Distance 5.4e8
	Radius 4.87e6
}

Galaxy "#AS377"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS377"
	AbsMag  -10.0  	Type "E0"
	RA 3.679
	Dec -55.21
	Distance 5.42e8
	Radius 3.44e6
}

Galaxy "#AS839"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS839"
	AbsMag  -10.0  	Type "E0"
	RA 20.023
	Dec -52.93
	Distance 5.43e8
	Radius 3.31e6
}

Galaxy "#AS1003"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1003"
	AbsMag  -10.0  	Type "E0"
	RA 22.223
	Dec -61.92
	Distance 5.43e8
	Radius 9.27e5
}

Galaxy "#AS1011"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1011"
	AbsMag  -10.0  	Type "E0"
	RA 22.333
	Dec -62.1
	Distance 5.43e8
	Radius 1.86e6
}

Galaxy "#A2593"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2593"
	AbsMag  -10.0  	Type "E0"
	RA 23.409
	Dec 14.64
	Distance 5.52e8
	Radius 4.48e6
}

Galaxy "#A3225"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3225"
	AbsMag  -10.0  	Type "E0"
	RA 4.155
	Dec -59.6
	Distance 5.52e8
	Radius 4.29e6
}

Galaxy "#AS889"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS889"
	AbsMag  -10.0  	Type "E0"
	RA 20.667
	Dec -53.06
	Distance 5.57e8
	Radius 2.47e6
}

Galaxy "#A147"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A147"
	AbsMag  -10.0  	Type "E0"
	RA 1.136
	Dec 2.17
	Distance 5.58e8
	Radius 4.09e6
}

Galaxy "#A119"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A119"
	AbsMag  -10.0  	Type "E0"
	RA 0.939
	Dec -1.26
	Distance 5.61e8
	Radius 5.28e6
}

Galaxy "#A957"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A957"
	AbsMag  -10.0  	Type "E0"
	RA 10.233
	Dec -0.92
	Distance 5.61e8
	Radius 4.9e6
}

Galaxy "#A1983"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1983"
	AbsMag  -10.0  	Type "E0"
	RA 14.879
	Dec 16.75
	Distance 5.62e8
	Radius 4.78e6
}

Galaxy "#AS601"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS601"
	AbsMag  -10.0  	Type "E0"
	RA 7.018
	Dec -49.74
	Distance 5.62e8
	Radius 3.25e6
}

Galaxy "#A2148"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2148"
	AbsMag  -10.0  	Type "E0"
	RA 16.055
	Dec 25.46
	Distance 5.63e8
	Radius 4.44e6
}

Galaxy "#A3338"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3338"
	AbsMag  -10.0  	Type "E0"
	RA 5.377
	Dec -48.27
	Distance 5.68e8
	Radius 4.05e6
}

Galaxy "#A160"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A160"
	AbsMag  -10.0  	Type "E0"
	RA 1.214
	Dec 15.51
	Distance 5.7e8
	Radius 4.17e6
}

Galaxy "#Abell 1644"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 1644"
	AbsMag  -10.0  	Type "E0"
	RA 12.954
	Dec -17.4
	Distance 5.72e8
	Radius 5.81e6
}

Galaxy "#A168"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A168"
	AbsMag  -10.0  	Type "E0"
	RA 1.253
	Dec 0.25
	Distance 5.76e8
	Radius 5.75e6
}

Galaxy "#AS393"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS393"
	AbsMag  -10.0  	Type "E0"
	RA 3.805
	Dec -45.55
	Distance 5.78e8
	Radius 2.87e6
}

Galaxy "#A1100"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1100"
	AbsMag  -10.0  	Type "E0"
	RA 10.815
	Dec 22.24
	Distance 5.8e8
	Radius 4.21e6
}

Galaxy "#A3376"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3376"
	AbsMag  -10.0  	Type "E0"
	RA 6.012
	Dec -40.05
	Distance 5.8e8
	Radius 4.48e6
}

Galaxy "#A2040"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2040"
	AbsMag  -10.0  	Type "E0"
	RA 15.213
	Dec 7.43
	Distance 5.81e8
	Radius 4.81e6
}

Galaxy "#A3716"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3716"
	AbsMag  -10.0  	Type "E0"
	RA 20.859
	Dec -52.71
	Distance 5.81e8
	Radius 5.21e6
}

Galaxy "#A4059"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A4059"
	AbsMag  -10.0  	Type "E0"
	RA 23.945
	Dec -34.67
	Distance 5.81e8
	Radius 5.21e6
}

Galaxy "#AS1157"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1157"
	AbsMag  -10.0  	Type "E0"
	RA 23.865
	Dec -34.42
	Distance 5.81e8
	Radius 3.44e6
}

Galaxy "#A261"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A261"
	AbsMag  -10.0  	Type "E0"
	RA 1.857
	Dec -2.24
	Distance 5.95e8
	Radius 5.13e6
}

Galaxy "#AS412"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS412"
	AbsMag  -10.0  	Type "E0"
	RA 4.028
	Dec -56.9
	Distance 5.95e8
	Radius 9.27e5
}

Galaxy "#AS906"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS906"
	AbsMag  -10.0  	Type "E0"
	RA 20.873
	Dec -51.96
	Distance 5.95e8
	Radius 3.96e6
}

Galaxy "#A1213"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1213"
	AbsMag  -10.0  	Type "E0"
	RA 11.275
	Dec 29.26
	Distance 5.96e8
	Radius 4.78e6
}

Galaxy "#A407"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A407"
	AbsMag  -10.0  	Type "E0"
	RA 3.029
	Dec 35.83
	Distance 5.98e8
	Radius 4.62e6
}

Galaxy "#AS835"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS835"
	AbsMag  -10.0  	Type "E0"
	RA 19.975
	Dec -52.63
	Distance 5.98e8
	Radius 3.18e6
}

Galaxy "#A3559"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3559"
	AbsMag  -10.0  	Type "E0"
	RA 13.498
	Dec -29.52
	Distance 6.0e8
	Radius 6.7e6
}

Galaxy "#Abell 533"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 533"
	AbsMag  -10.0  	Type "E0"
	RA 5.022
	Dec -22.63
	Distance 6.01e8
	Radius 4.29e6
}

Galaxy "#A480"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A480"
	AbsMag  -10.0  	Type "E0"
	RA 4.251
	Dec 0.99
	Distance 6.02e8
	Radius 4.41e6
}

Galaxy "#AS584"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS584"
	AbsMag  -10.0  	Type "E0"
	RA 6.383
	Dec -53.59
	Distance 6.02e8
	Radius 1.29e6
}

Galaxy "#A3653"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3653"
	AbsMag  -10.0  	Type "E0"
	RA 19.877
	Dec -52.02
	Distance 6.04e8
	Radius 4.48e6
}

Galaxy "#A1308"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1308"
	AbsMag  -10.0  	Type "E0"
	RA 11.547
	Dec -3.98
	Distance 6.12e8
	Radius 4.29e6
}

Galaxy "#AS1014"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1014"
	AbsMag  -10.0  	Type "E0"
	RA 22.403
	Dec -80.18
	Distance 6.12e8
	Radius 3.25e6
}

Galaxy "#A193"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A193"
	AbsMag  -10.0  	Type "E0"
	RA 1.419
	Dec 8.69
	Distance 6.13e8
	Radius 4.99e6
}

Galaxy "#A3558"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3558"
	AbsMag  -10.0  	Type "E0"
	RA 13.465
	Dec -31.49
	Distance 6.13e8
	Radius 7.84e6
}

Galaxy "#AS250"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS250"
	AbsMag  -10.0  	Type "E0"
	RA 2.371
	Dec -51.11
	Distance 6.16e8
	Radius 9.27e5
}

Galaxy "#A2824"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2824"
	AbsMag  -10.0  	Type "E0"
	RA 0.809
	Dec -21.34
	Distance 6.18e8
	Radius 4.62e6
}

Galaxy "#A3736"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3736"
	AbsMag  -10.0  	Type "E0"
	RA 21.055
	Dec -43.32
	Distance 6.19e8
	Radius 4.21e6
}

Galaxy "#AS919"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS919"
	AbsMag  -10.0  	Type "E0"
	RA 21.085
	Dec -43.43
	Distance 6.19e8
	Radius 2.34e6
}

Galaxy "#A376"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A376"
	AbsMag  -10.0  	Type "E0"
	RA 2.763
	Dec 36.86
	Distance 6.22e8
	Radius 4.25e6
}

Galaxy "#A671"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A671"
	AbsMag  -10.0  	Type "E0"
	RA 8.475
	Dec 30.42
	Distance 6.28e8
	Radius 4.33e6
}

Galaxy "#AS1066"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1066"
	AbsMag  -10.0  	Type "E0"
	RA 22.837
	Dec -46.27
	Distance 6.31e8
	Radius 3.77e6
}

Galaxy "#A2717"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2717"
	AbsMag  -10.0  	Type "E0"
	RA 0.054
	Dec -35.95
	Distance 6.33e8
	Radius 4.81e6
}

Galaxy "#A3395"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3395"
	AbsMag  -10.0  	Type "E0"
	RA 6.459
	Dec -54.4
	Distance 6.33e8
	Radius 4.87e6
}

Galaxy "#AS41"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS41"
	AbsMag  -10.0  	Type "E0"
	RA 0.425
	Dec -33.02
	Distance 6.33e8
	Radius 3.82e6
}

Galaxy "#A3562"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3562"
	AbsMag  -10.0  	Type "E0"
	RA 13.559
	Dec -31.67
	Distance 6.34e8
	Radius 6.51e6
}

Galaxy "#AS729"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS729"
	AbsMag  -10.0  	Type "E0"
	RA 13.359
	Dec -35.79
	Distance 6.34e8
	Radius 3.44e6
}

Galaxy "#AS1172"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1172"
	AbsMag  -10.0  	Type "E0"
	RA 0.023
	Dec -38.77
	Distance 6.36e8
	Radius 2.58e6
}

Galaxy "#AS734"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS734"
	AbsMag  -10.0  	Type "E0"
	RA 13.465
	Dec -41.13
	Distance 6.39e8
	Radius 2.58e6
}

Galaxy "#AS893"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS893"
	AbsMag  -10.0  	Type "E0"
	RA 20.755
	Dec -73.42
	Distance 6.39e8
	Radius 9.27e5
}

Galaxy "#A838"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A838"
	AbsMag  -10.0  	Type "E0"
	RA 9.619
	Dec -5.01
	Distance 6.44e8
	Radius 4.41e6
}

Galaxy "#A1631"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1631"
	AbsMag  -10.0  	Type "E0"
	RA 12.881
	Dec -15.44
	Distance 6.45e8
	Radius 4.17e6
}

Galaxy "#A2295"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2295"
	AbsMag  -10.0  	Type "E0"
	RA 17.999
	Dec 69.22
	Distance 6.45e8
	Radius 4.68e6
}

Galaxy "#AS801"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS801"
	AbsMag  -10.0  	Type "E0"
	RA 18.457
	Dec -51.54
	Distance 6.49e8
	Radius 9.27e5
}

Galaxy "#A1377"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1377"
	AbsMag  -10.0  	Type "E0"
	RA 11.783
	Dec 55.74
	Distance 6.53e8
	Radius 5.02e6
}

Galaxy "#A757"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A757"
	AbsMag  -10.0  	Type "E0"
	RA 9.213
	Dec 47.71
	Distance 6.54e8
	Radius 4.09e6
}

Galaxy "#A3925"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3925"
	AbsMag  -10.0  	Type "E0"
	RA 22.863
	Dec -46.58
	Distance 6.55e8
	Radius 4.33e6
}

Galaxy "#A85"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A85"
	AbsMag  -10.0  	Type "E0"
	RA 0.694
	Dec -9.34
	Distance 6.58e8
	Radius 5.02e6
}

Galaxy "#AS823"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS823"
	AbsMag  -10.0  	Type "E0"
	RA 19.659
	Dec -53.17
	Distance 6.58e8
	Radius 3.56e6
}

Galaxy "#AS542"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS542"
	AbsMag  -10.0  	Type "E0"
	RA 5.751
	Dec -48.1
	Distance 6.59e8
	Radius 3.72e6
}

Galaxy "#A1003"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1003"
	AbsMag  -10.0  	Type "E0"
	RA 10.418
	Dec 47.8
	Distance 6.6e8
	Radius 4.29e6
}

Galaxy "#A780"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A780"
	AbsMag  -10.0  	Type "E0"
	RA 9.309
	Dec -12.26
	Distance 6.63e8
	Radius 4.37e6
}

Galaxy "#A1216"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1216"
	AbsMag  -10.0  	Type "E0"
	RA 11.296
	Dec -4.47
	Distance 6.65e8
	Radius 4.96e6
}

Galaxy "#A151"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A151"
	AbsMag  -10.0  	Type "E0"
	RA 1.148
	Dec -15.42
	Distance 6.68e8
	Radius 5.36e6
}

Galaxy "#A978"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A978"
	AbsMag  -10.0  	Type "E0"
	RA 10.342
	Dec -6.52
	Distance 6.69e8
	Radius 4.9e6
}

Galaxy "#A754"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A754"
	AbsMag  -10.0  	Type "E0"
	RA 9.147
	Dec -9.64
	Distance 6.7e8
	Radius 5.81e6
}

Galaxy "#A3851"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3851"
	AbsMag  -10.0  	Type "E0"
	RA 22.279
	Dec -52.58
	Distance 6.71e8
	Radius 4.13e6
}

Galaxy "#A1291"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1291"
	AbsMag  -10.0  	Type "E0"
	RA 11.535
	Dec 56.02
	Distance 6.73e8
	Radius 5.07e6
}

Galaxy "#A2055"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2055"
	AbsMag  -10.0  	Type "E0"
	RA 15.313
	Dec 6.2
	Distance 6.73e8
	Radius 4.41e6
}

Galaxy "#A3667"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3667"
	AbsMag  -10.0  	Type "E0"
	RA 20.209
	Dec -56.82
	Distance 6.73e8
	Radius 5.67e6
}

Galaxy "#A3391"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3391"
	AbsMag  -10.0  	Type "E0"
	RA 6.437
	Dec -53.68
	Distance 6.74e8
	Radius 4.41e6
}

Galaxy "#AS329"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS329"
	AbsMag  -10.0  	Type "E0"
	RA 3.21
	Dec -49.63
	Distance 6.74e8
	Radius 9.27e5
}

Galaxy "#A993"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A993"
	AbsMag  -10.0  	Type "E0"
	RA 10.365
	Dec -4.95
	Distance 6.76e8
	Radius 4.25e6
}

Galaxy "#A1913"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1913"
	AbsMag  -10.0  	Type "E0"
	RA 14.448
	Dec 16.68
	Distance 6.76e8
	Radius 4.84e6
}

Galaxy "#AS968"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS968"
	AbsMag  -10.0  	Type "E0"
	RA 21.759
	Dec -51.6
	Distance 6.78e8
	Radius 3.5e6
}

Galaxy "#A117"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A117"
	AbsMag  -10.0  	Type "E0"
	RA 0.933
	Dec -10.03
	Distance 6.79e8
	Radius 4.41e6
}

Galaxy "#A1899"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1899"
	AbsMag  -10.0  	Type "E0"
	RA 14.356
	Dec 17.69
	Distance 6.8e8
	Radius 4.13e6
}

Galaxy "#AS854"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS854"
	AbsMag  -10.0  	Type "E0"
	RA 20.19
	Dec -56.73
	Distance 6.8e8
	Radius 3.72e6
}

Galaxy "#AS461"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS461"
	AbsMag  -10.0  	Type "E0"
	RA 4.47
	Dec -50.54
	Distance 6.84e8
	Radius 2.95e6
}

Galaxy "#A526"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A526"
	AbsMag  -10.0  	Type "E0"
	RA 4.998
	Dec 5.44
	Distance 6.86e8
	Radius 5.33e6
}

Galaxy "#A2366"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2366"
	AbsMag  -10.0  	Type "E0"
	RA 21.714
	Dec -6.87
	Distance 6.87e8
	Radius 4.65e6
}

Galaxy "#A505"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A505"
	AbsMag  -10.0  	Type "E0"
	RA 5.003
	Dec 80.01
	Distance 6.89e8
	Radius 4.37e6
}

Galaxy "#AS976"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS976"
	AbsMag  -10.0  	Type "E0"
	RA 21.824
	Dec -64.5
	Distance 6.89e8
	Radius 9.27e5
}

Galaxy "#AS113"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS113"
	AbsMag  -10.0  	Type "E0"
	RA 1.01
	Dec -40.23
	Distance 6.91e8
	Radius 2.95e6
}

Galaxy "#AS339"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS339"
	AbsMag  -10.0  	Type "E0"
	RA 3.321
	Dec -53.87
	Distance 6.92e8
	Radius 3.18e6
}

Galaxy "#A179"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A179"
	AbsMag  -10.0  	Type "E0"
	RA 1.363
	Dec 19.48
	Distance 6.94e8
	Radius 4.05e6
}

Galaxy "#A979"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A979"
	AbsMag  -10.0  	Type "E0"
	RA 10.34
	Dec -7.89
	Distance 6.97e8
	Radius 4.37e6
}

Galaxy "#A2184"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2184"
	AbsMag  -10.0  	Type "E0"
	RA 16.351
	Dec 50.2
	Distance 6.97e8
	Radius 4.05e6
}

Galaxy "#A3528"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3528"
	AbsMag  -10.0  	Type "E0"
	RA 12.905
	Dec -29.02
	Distance 7.01e8
	Radius 5.31e6
}

Galaxy "#A3128"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3128"
	AbsMag  -10.0  	Type "E0"
	RA 3.503
	Dec -52.56
	Distance 7.02e8
	Radius 6.69e6
}

Galaxy "#AS1039"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1039"
	AbsMag  -10.0  	Type "E0"
	RA 22.582
	Dec -52.46
	Distance 7.02e8
	Radius 3.72e6
}

Galaxy "#A1334"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1334"
	AbsMag  -10.0  	Type "E0"
	RA 11.647
	Dec -4.31
	Distance 7.03e8
	Radius 4.37e6
}

Galaxy "#A2665"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2665"
	AbsMag  -10.0  	Type "E0"
	RA 23.846
	Dec 6.11
	Distance 7.05e8
	Radius 4.17e6
}

Galaxy "#A3782"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3782"
	AbsMag  -10.0  	Type "E0"
	RA 21.575
	Dec -62.03
	Distance 7.06e8
	Radius 4.41e6
}

Galaxy "#A44"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A44"
	AbsMag  -10.0  	Type "E0"
	RA 0.493
	Dec 12.03
	Distance 7.08e8
	Radius 5.04e6
}

Galaxy "#A2022"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2022"
	AbsMag  -10.0  	Type "E0"
	RA 15.072
	Dec 28.42
	Distance 7.15e8
	Radius 4.75e6
}

Galaxy "#A2319"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2319"
	AbsMag  -10.0  	Type "E0"
	RA 19.346
	Dec 43.96
	Distance 7.15e8
	Radius 5.26e6
}

Galaxy "#AS1101"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1101"
	AbsMag  -10.0  	Type "E0"
	RA 23.233
	Dec -42.73
	Distance 7.15e8
	Radius 3.91e6
}

Galaxy "#A1318"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1318"
	AbsMag  -10.0  	Type "E0"
	RA 11.607
	Dec 54.96
	Distance 7.17e8
	Radius 4.93e6
}

Galaxy "#Abell 114"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 114"
	AbsMag  -10.0  	Type "E0"
	RA 0.899
	Dec -21.73
	Distance 7.17e8
	Radius 4.0e6
}

Galaxy "#A3380"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3380"
	AbsMag  -10.0  	Type "E0"
	RA 6.116
	Dec -49.49
	Distance 7.18e8
	Radius 4.41e6
}

Galaxy "#A2271"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2271"
	AbsMag  -10.0  	Type "E0"
	RA 17.288
	Dec 78.02
	Distance 7.19e8
	Radius 4.21e6
}

Galaxy "#AS955"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS955"
	AbsMag  -10.0  	Type "E0"
	RA 21.658
	Dec -83.34
	Distance 7.21e8
	Radius 3.87e6
}

Galaxy "#A1890"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1890"
	AbsMag  -10.0  	Type "E0"
	RA 14.293
	Dec 8.19
	Distance 7.22e8
	Radius 4.29e6
}

Galaxy "#A3231"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3231"
	AbsMag  -10.0  	Type "E0"
	RA 4.198
	Dec -64.61
	Distance 7.22e8
	Radius 5.18e6
}

Galaxy "#A2626"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2626"
	AbsMag  -10.0  	Type "E0"
	RA 23.609
	Dec 21.16
	Distance 7.26e8
	Radius 4.65e6
}

Galaxy "#AS261"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS261"
	AbsMag  -10.0  	Type "E0"
	RA 2.419
	Dec -63.23
	Distance 7.27e8
	Radius 3.38e6
}

Galaxy "#A358"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A358"
	AbsMag  -10.0  	Type "E0"
	RA 2.503
	Dec -13.2
	Distance 7.29e8
	Radius 4.17e6
}

Galaxy "#A2020"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2020"
	AbsMag  -10.0  	Type "E0"
	RA 15.063
	Dec 7.92
	Distance 7.32e8
	Radius 4.65e6
}

Galaxy "#A1169"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1169"
	AbsMag  -10.0  	Type "E0"
	RA 11.135
	Dec 43.95
	Distance 7.37e8
	Radius 5.38e6
}

Galaxy "#A3093"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3093"
	AbsMag  -10.0  	Type "E0"
	RA 3.181
	Dec -47.4
	Distance 7.40e8
	Radius 5.84e6
}

Galaxy "#AS324"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS324"
	AbsMag  -10.0  	Type "E0"
	RA 3.166
	Dec -47.33
	Distance 7.40e8
	Radius 2.68e6
}

Galaxy "#A1991"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1991"
	AbsMag  -10.0  	Type "E0"
	RA 14.909
	Dec 18.63
	Distance 7.42e8
	Radius 5.04e6
}

Galaxy "#AS303"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS303"
	AbsMag  -10.0  	Type "E0"
	RA 2.811
	Dec -71.38
	Distance 7.42e8
	Radius 2.2e6
}

Galaxy "#A2399"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2399"
	AbsMag  -10.0  	Type "E0"
	RA 21.959
	Dec -7.79
	Distance 7.43e8
	Radius 4.81e6
}

Galaxy "#A3651"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3651"
	AbsMag  -10.0  	Type "E0"
	RA 19.87
	Dec -55.09
	Distance 7.44e8
	Radius 5.43e6
}

Galaxy "#AS424"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS424"
	AbsMag  -10.0  	Type "E0"
	RA 4.127
	Dec -43.42
	Distance 7.45e8
	Radius 9.27e5
}

Galaxy "#A1749"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1749"
	AbsMag  -10.0  	Type "E0"
	RA 13.492
	Dec 37.63
	Distance 7.46e8
	Radius 4.9e6
}

Galaxy "#A3158"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3158"
	AbsMag  -10.0  	Type "E0"
	RA 3.717
	Dec -53.64
	Distance 7.46e8
	Radius 5.66e6
}

Galaxy "#AS726"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS726"
	AbsMag  -10.0  	Type "E0"
	RA 13.253
	Dec -33.65
	Distance 7.46e8
	Radius 2.95e6
}

Galaxy "#A1507"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1507"
	AbsMag  -10.0  	Type "E0"
	RA 12.264
	Dec 59.97
	Distance 7.49e8
	Radius 4.37e6
}

Galaxy "#A3125"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3125"
	AbsMag  -10.0  	Type "E0"
	RA 3.456
	Dec -53.51
	Distance 7.5e8
	Radius 4.62e6
}

Galaxy "#A3266"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3266"
	AbsMag  -10.0  	Type "E0"
	RA 4.519
	Dec -61.48
	Distance 7.51e8
	Radius 5.79e6
}

Galaxy "#A150"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A150"
	AbsMag  -10.0  	Type "E0"
	RA 1.154
	Dec 13.17
	Distance 7.54e8
	Radius 4.9e6
}

Galaxy "#AS974"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS974"
	AbsMag  -10.0  	Type "E0"
	RA 21.803
	Dec -46.02
	Distance 7.54e8
	Radius 3.38e6
}

Galaxy "#A2415"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2415"
	AbsMag  -10.0  	Type "E0"
	RA 22.09
	Dec -5.59
	Distance 7.55e8
	Radius 4.41e6
}

Galaxy "#A2457"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2457"
	AbsMag  -10.0  	Type "E0"
	RA 22.596
	Dec 1.48
	Distance 7.55e8
	Radius 4.84e6
}

Galaxy "#AS366"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS366"
	AbsMag  -10.0  	Type "E0"
	RA 3.583
	Dec -53.58
	Distance 7.56e8
	Radius 9.27e5
}

Galaxy "#A3078"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3078"
	AbsMag  -10.0  	Type "E0"
	RA 3.007
	Dec -51.84
	Distance 7.59e8
	Radius 4.41e6
}

Galaxy "#A2256"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2256"
	AbsMag  -10.0  	Type "E0"
	RA 17.062
	Dec 78.72
	Distance 7.6e8
	Radius 5.73e6
}

Galaxy "#AS927"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS927"
	AbsMag  -10.0  	Type "E0"
	RA 21.283
	Dec -59.41
	Distance 7.61e8
	Radius 3.96e6
}

Galaxy "#A1275"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1275"
	AbsMag  -10.0  	Type "E0"
	RA 11.499
	Dec 36.67
	Distance 7.62e8
	Radius 4.58e6
}

Galaxy "#A1383"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1383"
	AbsMag  -10.0  	Type "E0"
	RA 11.803
	Dec 54.62
	Distance 7.62e8
	Radius 4.87e6
}

Galaxy "#Abell 133"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 133"
	AbsMag  -10.0  	Type "E0"
	RA 1.046
	Dec -21.88
	Distance 7.64e8
	Radius 5.04e6
}

Galaxy "#AS390"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS390"
	AbsMag  -10.0  	Type "E0"
	RA 3.783
	Dec -54.03
	Distance 7.65e8
	Radius 9.27e5
}

Galaxy "#A450"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A450"
	AbsMag  -10.0  	Type "E0"
	RA 3.694
	Dec 23.49
	Distance 7.67e8
	Radius 4.41e6
}

Galaxy "#A2625"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2625"
	AbsMag  -10.0  	Type "E0"
	RA 23.605
	Dec 20.53
	Distance 7.7e8
	Radius 4.58e6
}

Galaxy "#Abell 86"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 86"
	AbsMag  -10.0  	Type "E0"
	RA 0.711
	Dec -21.79
	Distance 7.71e8
	Radius 4.44e6
}

Galaxy "#A3164"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3164"
	AbsMag  -10.0  	Type "E0"
	RA 3.764
	Dec -57.05
	Distance 7.72e8
	Radius 4.13e6
}

Galaxy "#A2388"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2388"
	AbsMag  -10.0  	Type "E0"
	RA 21.893
	Dec 8.24
	Distance 7.77e8
	Radius 4.62e6
}

Galaxy "#A1795"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1795"
	AbsMag  -10.0  	Type "E0"
	RA 13.817
	Dec 26.59
	Distance 7.78e8
	Radius 6.26e6
}

Galaxy "#A240"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A240"
	AbsMag  -10.0  	Type "E0"
	RA 1.699
	Dec 7.62
	Distance 7.81e8
	Radius 4.51e6
}

Galaxy "#A1825"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1825"
	AbsMag  -10.0  	Type "E0"
	RA 13.966
	Dec 20.66
	Distance 7.81e8
	Radius 4.71e6
}

Galaxy "#AS315"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS315"
	AbsMag  -10.0  	Type "E0"
	RA 2.987
	Dec -51.02
	Distance 7.81e8
	Radius 9.27e5
}

Galaxy "#A3685"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3685"
	AbsMag  -10.0  	Type "E0"
	RA 20.537
	Dec -56.43
	Distance 7.83e8
	Radius 4.0e6
}

Galaxy "#A2622"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2622"
	AbsMag  -10.0  	Type "E0"
	RA 23.581
	Dec 27.43
	Distance 7.84e8
	Radius 4.44e6
}

Galaxy "#A592"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A592"
	AbsMag  -10.0  	Type "E0"
	RA 7.711
	Dec 9.36
	Distance 7.88e8
	Radius 4.84e6
}

Galaxy "#A75"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A75"
	AbsMag  -10.0  	Type "E0"
	RA 0.664
	Dec 21.26
	Distance 7.91e8
	Radius 4.48e6
}

Galaxy "#A1254"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1254"
	AbsMag  -10.0  	Type "E0"
	RA 11.447
	Dec 71.07
	Distance 7.93e8
	Radius 4.99e6
}

Galaxy "#A1069"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1069"
	AbsMag  -10.0  	Type "E0"
	RA 10.665
	Dec -8.61
	Distance 7.95e8
	Radius 4.58e6
}

Galaxy "#A1452"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1452"
	AbsMag  -10.0  	Type "E0"
	RA 12.061
	Dec 51.74
	Distance 7.97e8
	Radius 4.62e6
}

Galaxy "#A3009"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3009"
	AbsMag  -10.0  	Type "E0"
	RA 2.369
	Dec -48.57
	Distance 7.97e8
	Radius 4.87e6
}

Galaxy "#A102"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A102"
	AbsMag  -10.0  	Type "E0"
	RA 0.811
	Dec 1.37
	Distance 7.98e8
	Radius 4.37e6
}

Galaxy "#A3108"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3108"
	AbsMag  -10.0  	Type "E0"
	RA 3.254
	Dec -47.63
	Distance 7.98e8
	Radius 5.38e6
}

Galaxy "#A2241"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2241"
	AbsMag  -10.0  	Type "E0"
	RA 16.995
	Dec 32.54
	Distance 8.02e8
	Radius 4.0e6
}

Galaxy "#A3004"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3004"
	AbsMag  -10.0  	Type "E0"
	RA 2.314
	Dec -48.0
	Distance 8.02e8
	Radius 4.25e6
}

Galaxy "#AS239"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS239"
	AbsMag  -10.0  	Type "E0"
	RA 2.279
	Dec -47.82
	Distance 8.02e8
	Radius 3.5e6
}

Galaxy "#Abell 14"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 14"
	AbsMag  -10.0  	Type "E0"
	RA 0.252
	Dec -23.89
	Distance 8.08e8
	Radius 3.96e6
}

Galaxy "#A2004"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2004"
	AbsMag  -10.0  	Type "E0"
	RA 14.977
	Dec 24.93
	Distance 8.08e8
	Radius 4.17e6
}

Galaxy "#AS957"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS957"
	AbsMag  -10.0  	Type "E0"
	RA 21.594
	Dec -52.54
	Distance 8.08e8
	Radius 2.95e6
}

Galaxy "#A2764"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2764"
	AbsMag  -10.0  	Type "E0"
	RA 0.341
	Dec -49.22
	Distance 8.09e8
	Radius 4.9e6
}

Galaxy "#AS1071"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1071"
	AbsMag  -10.0  	Type "E0"
	RA 22.899
	Dec -17.63
	Distance 8.1e8
	Radius 9.27e5
}

Galaxy "#A158"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A158"
	AbsMag  -10.0  	Type "E0"
	RA 1.196
	Dec 16.88
	Distance 8.14e8
	Radius 4.62e6
}

Galaxy "#A3106"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3106"
	AbsMag  -10.0  	Type "E0"
	RA 3.242
	Dec -58.1
	Distance 8.14e8
	Radius 4.55e6
}

Galaxy "#A1436"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1436"
	AbsMag  -10.0  	Type "E0"
	RA 12.008
	Dec 56.26
	Distance 8.15e8
	Radius 5.28e6
}

Galaxy "#A2382"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2382"
	AbsMag  -10.0  	Type "E0"
	RA 21.867
	Dec -15.65
	Distance 8.17e8
	Radius 4.75e6
}

Galaxy "#AS416"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS416"
	AbsMag  -10.0  	Type "E0"
	RA 4.081
	Dec -43.85
	Distance 8.17e8
	Radius 9.27e5
}

Galaxy "#A1630"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1630"
	AbsMag  -10.0  	Type "E0"
	RA 12.863
	Dec 4.56
	Distance 8.19e8
	Radius 4.87e6
}

Galaxy "#A2988"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2988"
	AbsMag  -10.0  	Type "E0"
	RA 2.215
	Dec -47.13
	Distance 8.19e8
	Radius 5.36e6
}

Galaxy "#A1020"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1020"
	AbsMag  -10.0  	Type "E0"
	RA 10.464
	Dec 10.41
	Distance 8.2e8
	Radius 5.26e6
}

Galaxy "#A3123"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3123"
	AbsMag  -10.0  	Type "E0"
	RA 3.383
	Dec -52.02
	Distance 8.2e8
	Radius 4.29e6
}

Galaxy "#A3831"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3831"
	AbsMag  -10.0  	Type "E0"
	RA 22.055
	Dec -45.82
	Distance 8.2e8
	Radius 5.57e6
}

Galaxy "#A2124"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2124"
	AbsMag  -10.0  	Type "E0"
	RA 15.75
	Dec 36.06
	Distance 8.25e8
	Radius 4.75e6
}

Galaxy "#A2250"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2250"
	AbsMag  -10.0  	Type "E0"
	RA 17.179
	Dec 39.69
	Distance 8.25e8
	Radius 4.81e6
}

Galaxy "#A2469"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2469"
	AbsMag  -10.0  	Type "E0"
	RA 22.675
	Dec 12.26
	Distance 8.27e8
	Radius 5.07e6
}

Galaxy "#A154"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A154"
	AbsMag  -10.0  	Type "E0"
	RA 1.183
	Dec 17.67
	Distance 8.3e8
	Radius 5.21e6
}

Galaxy "#A2079"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2079"
	AbsMag  -10.0  	Type "E0"
	RA 15.468
	Dec 28.88
	Distance 8.34e8
	Radius 4.96e6
}

Galaxy "#A2248"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2248"
	AbsMag  -10.0  	Type "E0"
	RA 16.963
	Dec 77.01
	Distance 8.36e8
	Radius 4.17e6
}

Galaxy "#A116"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A116"
	AbsMag  -10.0  	Type "E0"
	RA 0.931
	Dec 0.64
	Distance 8.38e8
	Radius 4.68e6
}

Galaxy "#A595"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A595"
	AbsMag  -10.0  	Type "E0"
	RA 7.814
	Dec 52.07
	Distance 8.39e8
	Radius 4.58e6
}

Galaxy "#AS367"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS367"
	AbsMag  -10.0  	Type "E0"
	RA 3.591
	Dec -45.17
	Distance 8.39e8
	Radius 9.27e5
}

Galaxy "#Abell 500"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 500"
	AbsMag  -10.0  	Type "E0"
	RA 4.647
	Dec -22.12
	Distance 8.39e8
	Radius 4.99e6
}

Galaxy "#A2889"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2889"
	AbsMag  -10.0  	Type "E0"
	RA 1.246
	Dec -48.5
	Distance 8.41e8
	Radius 5.18e6
}

Galaxy "#A1827"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1827"
	AbsMag  -10.0  	Type "E0"
	RA 13.971
	Dec 21.71
	Distance 8.42e8
	Radius 5.26e6
}

Galaxy "#AS433"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS433"
	AbsMag  -10.0  	Type "E0"
	RA 4.242
	Dec -50.79
	Distance 8.42e8
	Radius 1.62e6
}

Galaxy "#A2092"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2092"
	AbsMag  -10.0  	Type "E0"
	RA 15.555
	Dec 31.15
	Distance 8.43e8
	Radius 4.9e6
}

Galaxy "#A553"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A553"
	AbsMag  -10.0  	Type "E0"
	RA 6.211
	Dec 48.6
	Distance 8.44e8
	Radius 4.0e6
}

Galaxy "#AS346"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS346"
	AbsMag  -10.0  	Type "E0"
	RA 3.373
	Dec -49.32
	Distance 8.44e8
	Radius 2.58e6
}

Galaxy "#A3109"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3109"
	AbsMag  -10.0  	Type "E0"
	RA 3.277
	Dec -43.85
	Distance 8.48e8
	Radius 4.09e6
}

Galaxy "#A2630"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2630"
	AbsMag  -10.0  	Type "E0"
	RA 23.625
	Dec 15.83
	Distance 8.5e8
	Radius 4.05e6
}

Galaxy "#AS468"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS468"
	AbsMag  -10.0  	Type "E0"
	RA 4.528
	Dec -46.11
	Distance 8.5e8
	Radius 1.29e6
}

Galaxy "#A3849"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3849"
	AbsMag  -10.0  	Type "E0"
	RA 22.265
	Dec -51.55
	Distance 8.54e8
	Radius 4.48e6
}

Galaxy "#AS1140"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1140"
	AbsMag  -10.0  	Type "E0"
	RA 23.658
	Dec -45.97
	Distance 8.59e8
	Radius 1.86e6
}

Galaxy "#AS811"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS811"
	AbsMag  -10.0  	Type "E0"
	RA 19.287
	Dec -52.43
	Distance 8.66e8
	Radius 9.27e5
}

Galaxy "#A1270"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1270"
	AbsMag  -10.0  	Type "E0"
	RA 11.491
	Dec 54.06
	Distance 8.67e8
	Radius 4.41e6
}

Galaxy "#AS958"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS958"
	AbsMag  -10.0  	Type "E0"
	RA 21.604
	Dec -56.19
	Distance 8.7e8
	Radius 3.5e6
}

Galaxy "#A225"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A225"
	AbsMag  -10.0  	Type "E0"
	RA 1.649
	Dec 18.89
	Distance 8.71e8
	Radius 4.78e6
}

Galaxy "#A695"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A695"
	AbsMag  -10.0  	Type "E0"
	RA 8.69
	Dec 32.29
	Distance 8.73e8
	Radius 5.13e6
}

Galaxy "#A1775"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1775"
	AbsMag  -10.0  	Type "E0"
	RA 13.699
	Dec 26.36
	Distance 8.76e8
	Radius 5.81e6
}

Galaxy "#A3120"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3120"
	AbsMag  -10.0  	Type "E0"
	RA 3.365
	Dec -51.32
	Distance 8.76e8
	Radius 4.41e6
}

Galaxy "#A1356"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1356"
	AbsMag  -10.0  	Type "E0"
	RA 11.708
	Dec 10.44
	Distance 8.78e8
	Radius 5.48e6
}

Galaxy "#Abell 2462"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2462"
	AbsMag  -10.0  	Type "E0"
	RA 22.653
	Dec -17.34
	Distance 8.78e8
	Radius 4.09e6
}

Galaxy "#A3969"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3969"
	AbsMag  -10.0  	Type "E0"
	RA 23.094
	Dec -44.15
	Distance 8.79e8
	Radius 4.9e6
}

Galaxy "#AS1080"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1080"
	AbsMag  -10.0  	Type "E0"
	RA 23.027
	Dec -44.0
	Distance 8.79e8
	Radius 3.56e6
}

Galaxy "#A246"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A246"
	AbsMag  -10.0  	Type "E0"
	RA 1.745
	Dec 5.8
	Distance 8.81e8
	Radius 4.93e6
}

Galaxy "#A1767"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1767"
	AbsMag  -10.0  	Type "E0"
	RA 13.6
	Dec 59.21
	Distance 8.82e8
	Radius 5.18e6
}

Galaxy "#AS1142"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1142"
	AbsMag  -10.0  	Type "E0"
	RA 23.689
	Dec -30.22
	Distance 8.82e8
	Radius 3.5e6
}

Galaxy "#A3112"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3112"
	AbsMag  -10.0  	Type "E0"
	RA 3.299
	Dec -44.23
	Distance 8.84e8
	Radius 6.28e6
}

Galaxy "#A644"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A644"
	AbsMag  -10.0  	Type "E0"
	RA 8.291
	Dec -7.59
	Distance 8.85e8
	Radius 4.48e6
}

Galaxy "#A2618"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2618"
	AbsMag  -10.0  	Type "E0"
	RA 23.563
	Dec 23.01
	Distance 8.87e8
	Radius 4.21e6
}

Galaxy "#AS1147"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1147"
	AbsMag  -10.0  	Type "E0"
	RA 23.774
	Dec -46.97
	Distance 8.87e8
	Radius 2.05e6
}

Galaxy "#A171"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A171"
	AbsMag  -10.0  	Type "E0"
	RA 1.279
	Dec 16.26
	Distance 8.88e8
	Radius 4.48e6
}

Galaxy "#A257"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A257"
	AbsMag  -10.0  	Type "E0"
	RA 1.817
	Dec 13.98
	Distance 8.88e8
	Radius 4.78e6
}

Galaxy "#A1904"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1904"
	AbsMag  -10.0  	Type "E0"
	RA 14.369
	Dec 48.56
	Distance 8.9e8
	Radius 5.62e6
}

Galaxy "#A3703"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3703"
	AbsMag  -10.0  	Type "E0"
	RA 20.667
	Dec -61.34
	Distance 8.9e8
	Radius 4.81e6
}

Galaxy "#A1149"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1149"
	AbsMag  -10.0  	Type "E0"
	RA 11.05
	Dec 7.63
	Distance 8.93e8
	Radius 4.17e6
}

Galaxy "#A399"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A399"
	AbsMag  -10.0  	Type "E0"
	RA 2.966
	Dec 13.02
	Distance 8.99e8
	Radius 4.96e6
}

Galaxy "#A1238"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1238"
	AbsMag  -10.0  	Type "E0"
	RA 11.383
	Dec 1.09
	Distance 9.0e8
	Radius 5.13e6
}

Galaxy "#A1589"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1589"
	AbsMag  -10.0  	Type "E0"
	RA 12.693
	Dec 18.59
	Distance 9.02e8
	Radius 4.33e6
}

Galaxy "#A77"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A77"
	AbsMag  -10.0  	Type "E0"
	RA 0.676
	Dec 29.52
	Distance 9.04e8
	Radius 4.75e6
}

Galaxy "#A2065"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2065"
	AbsMag  -10.0  	Type "E0"
	RA 15.379
	Dec 27.72
	Distance 9.06e8
	Radius 6.15e6
}

Galaxy "#A1691"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1691"
	AbsMag  -10.0  	Type "E0"
	RA 13.19
	Dec 39.2
	Distance 9.07e8
	Radius 5.15e6
}

Galaxy "#AS1061"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1061"
	AbsMag  -10.0  	Type "E0"
	RA 22.833
	Dec -84.14
	Distance 9.08e8
	Radius 9.27e5
}

Galaxy "#A71"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A71"
	AbsMag  -10.0  	Type "E0"
	RA 0.629
	Dec 29.59
	Distance 9.1e8
	Radius 4.0e6
}

Galaxy "#A1800"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1800"
	AbsMag  -10.0  	Type "E0"
	RA 13.828
	Dec 28.07
	Distance 9.1e8
	Radius 4.41e6
}

Galaxy "#A2675"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2675"
	AbsMag  -10.0  	Type "E0"
	RA 23.926
	Dec 11.43
	Distance 9.12e8
	Radius 5.04e6
}

Galaxy "#A744"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A744"
	AbsMag  -10.0  	Type "E0"
	RA 9.121
	Dec 16.66
	Distance 9.16e8
	Radius 4.48e6
}

Galaxy "#Abell 514"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 514"
	AbsMag  -10.0  	Type "E0"
	RA 4.798
	Dec -20.43
	Distance 9.18e8
	Radius 5.04e6
}

Galaxy "#A2067"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2067"
	AbsMag  -10.0  	Type "E0"
	RA 15.387
	Dec 30.91
	Distance 9.19e8
	Radius 4.99e6
}

Galaxy "#A1831"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1831"
	AbsMag  -10.0  	Type "E0"
	RA 13.986
	Dec 27.99
	Distance 9.21e8
	Radius 5.23e6
}

Galaxy "#Abell 2412"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2412"
	AbsMag  -10.0  	Type "E0"
	RA 22.068
	Dec -21.44
	Distance 9.23e8
	Radius 3.66e6
}

Galaxy "#A2459"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2459"
	AbsMag  -10.0  	Type "E0"
	RA 22.609
	Dec -15.66
	Distance 9.24e8
	Radius 4.13e6
}

Galaxy "#A1927"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1927"
	AbsMag  -10.0  	Type "E0"
	RA 14.517
	Dec 25.66
	Distance 9.29e8
	Radius 4.75e6
}

Galaxy "#A2089"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2089"
	AbsMag  -10.0  	Type "E0"
	RA 15.545
	Dec 28.02
	Distance 9.33e8
	Radius 5.31e6
}

Galaxy "#A3825"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3825"
	AbsMag  -10.0  	Type "E0"
	RA 21.973
	Dec -60.39
	Distance 9.34e8
	Radius 5.48e6
}

Galaxy "#AS336"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS336"
	AbsMag  -10.0  	Type "E0"
	RA 3.292
	Dec -44.7
	Distance 9.34e8
	Radius 2.2e6
}

Galaxy "#A2670"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2670"
	AbsMag  -10.0  	Type "E0"
	RA 23.903
	Dec -10.41
	Distance 9.35e8
	Radius 6.72e6
}

Galaxy "#A3806"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3806"
	AbsMag  -10.0  	Type "E0"
	RA 21.777
	Dec -57.29
	Distance 9.37e8
	Radius 6.26e6
}

Galaxy "#A401"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A401"
	AbsMag  -10.0  	Type "E0"
	RA 2.983
	Dec 13.58
	Distance 9.39e8
	Radius 5.77e6
}

Galaxy "#A3886"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3886"
	AbsMag  -10.0  	Type "E0"
	RA 22.528
	Dec -54.74
	Distance 9.41e8
	Radius 4.05e6
}

Galaxy "#A568"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A568"
	AbsMag  -10.0  	Type "E0"
	RA 7.127
	Dec 35.04
	Distance 9.42e8
	Radius 4.25e6
}

Galaxy "#A3826"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3826"
	AbsMag  -10.0  	Type "E0"
	RA 21.999
	Dec -58.16
	Distance 9.46e8
	Radius 5.1e6
}

Galaxy "#A3110"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3110"
	AbsMag  -10.0  	Type "E0"
	RA 3.275
	Dec -50.9
	Distance 9.47e8
	Radius 4.29e6
}

Galaxy "#A3796"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3796"
	AbsMag  -10.0  	Type "E0"
	RA 21.658
	Dec -51.39
	Distance 9.48e8
	Radius 4.62e6
}

Galaxy "#A559"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A559"
	AbsMag  -10.0  	Type "E0"
	RA 6.669
	Dec 69.69
	Distance 9.5e8
	Radius 4.13e6
}

Galaxy "#AS372"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS372"
	AbsMag  -10.0  	Type "E0"
	RA 3.621
	Dec -55.42
	Distance 9.51e8
	Radius 2.47e6
}

Galaxy "#A819"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A819"
	AbsMag  -10.0  	Type "E0"
	RA 9.538
	Dec 9.66
	Distance 9.52e8
	Radius 4.25e6
}

Galaxy "#A3687"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3687"
	AbsMag  -10.0  	Type "E0"
	RA 20.557
	Dec -63.03
	Distance 9.52e8
	Radius 4.62e6
}

Galaxy "#A3822"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3822"
	AbsMag  -10.0  	Type "E0"
	RA 21.902
	Dec -57.85
	Distance 9.53e8
	Radius 6.23e6
}

Galaxy "#A1781"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1781"
	AbsMag  -10.0  	Type "E0"
	RA 13.741
	Dec 29.85
	Distance 9.56e8
	Radius 4.44e6
}

Galaxy "#A1365"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1365"
	AbsMag  -10.0  	Type "E0"
	RA 11.74
	Dec 30.91
	Distance 9.57e8
	Radius 4.78e6
}

Galaxy "#A2056"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2056"
	AbsMag  -10.0  	Type "E0"
	RA 15.32
	Dec 28.27
	Distance 9.57e8
	Radius 4.75e6
}

Galaxy "#A1783"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1783"
	AbsMag  -10.0  	Type "E0"
	RA 13.723
	Dec 55.6
	Distance 9.6e8
	Radius 4.65e6
}

Galaxy "#A2029"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2029"
	AbsMag  -10.0  	Type "E0"
	RA 15.183
	Dec 5.76
	Distance 9.62e8
	Radius 5.6e6
}

Galaxy "#A2061"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2061"
	AbsMag  -10.0  	Type "E0"
	RA 15.354
	Dec 30.65
	Distance 9.63e8
	Radius 5.33e6
}

Galaxy "#AS501"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS501"
	AbsMag  -10.0  	Type "E0"
	RA 4.836
	Dec -51.13
	Distance 9.63e8
	Radius 1.62e6
}

Galaxy "#A2177"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2177"
	AbsMag  -10.0  	Type "E0"
	RA 16.349
	Dec 25.75
	Distance 9.64e8
	Radius 4.55e6
}

Galaxy "#A2028"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2028"
	AbsMag  -10.0  	Type "E0"
	RA 15.159
	Dec 7.53
	Distance 9.68e8
	Radius 4.75e6
}

Galaxy "#A3785"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3785"
	AbsMag  -10.0  	Type "E0"
	RA 21.575
	Dec -53.63
	Distance 9.71e8
	Radius 4.58e6
}

Galaxy "#A1873"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1873"
	AbsMag  -10.0  	Type "E0"
	RA 14.195
	Dec 28.15
	Distance 9.72e8
	Radius 4.44e6
}

Galaxy "#A1400"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1400"
	AbsMag  -10.0  	Type "E0"
	RA 11.857
	Dec 55.11
	Distance 9.75e8
	Radius 4.33e6
}

Galaxy "#A564"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A564"
	AbsMag  -10.0  	Type "E0"
	RA 7.011
	Dec 69.81
	Distance 9.76e8
	Radius 4.93e6
}

Galaxy "#A1569"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1569"
	AbsMag  -10.0  	Type "E0"
	RA 12.605
	Dec 16.59
	Distance 9.82e8
	Radius 4.41e6
}

Galaxy "#A415"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A415"
	AbsMag  -10.0  	Type "E0"
	RA 3.113
	Dec -12.04
	Distance 9.87e8
	Radius 5.23e6
}

Galaxy "#A690"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A690"
	AbsMag  -10.0  	Type "E0"
	RA 8.654
	Dec 28.84
	Distance 9.87e8
	Radius 4.81e6
}

Galaxy "#A1809"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1809"
	AbsMag  -10.0  	Type "E0"
	RA 13.889
	Dec 5.15
	Distance 9.87e8
	Radius 5.5e6
}

Galaxy "#AS1023"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1023"
	AbsMag  -10.0  	Type "E0"
	RA 22.427
	Dec -55.83
	Distance 9.88e8
	Radius 3.87e6
}

Galaxy "#A245"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A245"
	AbsMag  -10.0  	Type "E0"
	RA 1.735
	Dec 6.38
	Distance 9.89e8
	Radius 4.41e6
}

Galaxy "#A680"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A680"
	AbsMag  -10.0  	Type "E0"
	RA 8.589
	Dec 36.86
	Distance 9.89e8
	Radius 5.07e6
}

Galaxy "#A1186"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1186"
	AbsMag  -10.0  	Type "E0"
	RA 11.231
	Dec 75.39
	Distance 9.9e8
	Radius 6.11e6
}

Galaxy "#A1187"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1187"
	AbsMag  -10.0  	Type "E0"
	RA 11.195
	Dec 39.58
	Distance 9.9e8
	Radius 4.9e6
}

Galaxy "#A1474"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1474"
	AbsMag  -10.0  	Type "E0"
	RA 12.133
	Dec 14.96
	Distance 9.9e8
	Radius 5.31e6
}

Galaxy "#A1218"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1218"
	AbsMag  -10.0  	Type "E0"
	RA 11.314
	Dec 51.71
	Distance 9.92e8
	Radius 4.65e6
}

Galaxy "#A527"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A527"
	AbsMag  -10.0  	Type "E0"
	RA 5.171
	Dec 73.7
	Distance 9.94e8
	Radius 4.17e6
}

Galaxy "#A1190"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1190"
	AbsMag  -10.0  	Type "E0"
	RA 11.196
	Dec 40.84
	Distance 9.94e8
	Radius 5.71e6
}

Galaxy "#A2559"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2559"
	AbsMag  -10.0  	Type "E0"
	RA 23.219
	Dec -13.69
	Distance 9.96e8
	Radius 5.38e6
}

Galaxy "#A3771"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3771"
	AbsMag  -10.0  	Type "E0"
	RA 21.492
	Dec -50.81
	Distance 9.96e8
	Radius 4.48e6
}

Galaxy "#A279"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A279"
	AbsMag  -10.0  	Type "E0"
	RA 1.939
	Dec 1.06
	Distance 9.98e8
	Radius 5.31e6
}

Galaxy "#A423"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A423"
	AbsMag  -10.0  	Type "E0"
	RA 3.188
	Dec -12.11
	Distance 9.98e8
	Radius 5.75e6
}

Galaxy "#A2198"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2198"
	AbsMag  -10.0  	Type "E0"
	RA 16.468
	Dec 43.82
	Distance 9.99e8
	Radius 5.66e6
}

Galaxy "#A1035"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1035"
	AbsMag  -10.0  	Type "E0"
	RA 10.535
	Dec 40.21
	Distance 1.0e9
	Radius 5.86e6
}

Galaxy "#A2255"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2255"
	AbsMag  -10.0  	Type "E0"
	RA 17.209
	Dec 64.09
	Distance 1.001e9
	Radius 6.02e6
}

Galaxy "#A449"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A449"
	AbsMag  -10.0  	Type "E0"
	RA 3.826
	Dec 75.19
	Distance 1.004e9
	Radius 4.93e6
}

Galaxy "#A2410"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2410"
	AbsMag  -10.0  	Type "E0"
	RA 22.035
	Dec -9.89
	Distance 1.008e9
	Radius 4.87e6
}

Galaxy "#A2377"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2377"
	AbsMag  -10.0  	Type "E0"
	RA 21.766
	Dec -10.04
	Distance 1.011e9
	Radius 5.86e6
}

Galaxy "#A2249"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2249"
	AbsMag  -10.0  	Type "E0"
	RA 17.162
	Dec 34.46
	Distance 1.012e9
	Radius 4.37e6
}

Galaxy "#A2448"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2448"
	AbsMag  -10.0  	Type "E0"
	RA 22.529
	Dec -8.44
	Distance 1.013e9
	Radius 4.25e6
}

Galaxy "#Abell 2538"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2538"
	AbsMag  -10.0  	Type "E0"
	RA 23.143
	Dec -19.91
	Distance 1.022e9
	Radius 5.62e6
}

Galaxy "#Abell 2566"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2566"
	AbsMag  -10.0  	Type "E0"
	RA 23.271
	Dec -20.49
	Distance 1.026e9
	Radius 5.23e6
}

Galaxy "#A104"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A104"
	AbsMag  -10.0  	Type "E0"
	RA 0.829
	Dec 24.52
	Distance 1.028e9
	Radius 4.75e6
}

Galaxy "#A1651"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1651"
	AbsMag  -10.0  	Type "E0"
	RA 12.99
	Dec -4.19
	Distance 1.031e9
	Radius 5.31e6
}

Galaxy "#A2638"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2638"
	AbsMag  -10.0  	Type "E0"
	RA 23.675
	Dec -11.71
	Distance 1.031e9
	Radius 6.41e6
}

Galaxy "#A1337"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1337"
	AbsMag  -10.0  	Type "E0"
	RA 11.657
	Dec 10.16
	Distance 1.032e9
	Radius 4.75e6
}

Galaxy "#A1385"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1385"
	AbsMag  -10.0  	Type "E0"
	RA 11.801
	Dec 11.56
	Distance 1.038e9
	Radius 4.81e6
}

Galaxy "#A1616"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1616"
	AbsMag  -10.0  	Type "E0"
	RA 12.794
	Dec 55.04
	Distance 1.041e9
	Radius 4.37e6
}

Galaxy "#A509"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A509"
	AbsMag  -10.0  	Type "E0"
	RA 4.795
	Dec 2.29
	Distance 1.044e9
	Radius 5.36e6
}

Galaxy "#A1552"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1552"
	AbsMag  -10.0  	Type "E0"
	RA 12.497
	Dec 11.74
	Distance 1.046e9
	Radius 5.43e6
}

Galaxy "#A16"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A16"
	AbsMag  -10.0  	Type "E0"
	RA 0.279
	Dec 6.74
	Distance 1.047e9
	Radius 5.69e6
}

Galaxy "#A2420"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2420"
	AbsMag  -10.0  	Type "E0"
	RA 22.173
	Dec -12.19
	Distance 1.047e9
	Radius 5.73e6
}

Galaxy "#A1412"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1412"
	AbsMag  -10.0  	Type "E0"
	RA 11.929
	Dec 73.47
	Distance 1.048e9
	Radius 5.69e6
}

Galaxy "#A1468"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1468"
	AbsMag  -10.0  	Type "E0"
	RA 12.094
	Dec 51.42
	Distance 1.054e9
	Radius 4.75e6
}

Galaxy "#A1650"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1650"
	AbsMag  -10.0  	Type "E0"
	RA 12.979
	Dec -1.75
	Distance 1.055e9
	Radius 6.25e6
}

Galaxy "#A1793"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1793"
	AbsMag  -10.0  	Type "E0"
	RA 13.806
	Dec 32.28
	Distance 1.06e9
	Radius 4.87e6
}

Galaxy "#A1126"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1126"
	AbsMag  -10.0  	Type "E0"
	RA 10.899
	Dec 16.85
	Distance 1.063e9
	Radius 4.9e6
}

Galaxy "#A2597"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2597"
	AbsMag  -10.0  	Type "E0"
	RA 23.422
	Dec -12.11
	Distance 1.063e9
	Radius 4.51e6
}

Galaxy "#A3629"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3629"
	AbsMag  -10.0  	Type "E0"
	RA 16.654
	Dec -82.47
	Distance 1.066e9
	Radius 4.09e6
}

Galaxy "#A465"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A465"
	AbsMag  -10.0  	Type "E0"
	RA 3.849
	Dec 6.3
	Distance 1.067e9
	Radius 5.13e6
}

Galaxy "#A1750"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1750"
	AbsMag  -10.0  	Type "E0"
	RA 13.515
	Dec -1.84
	Distance 1.073e9
	Radius 4.41e6
}

Galaxy "#A3126"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3126"
	AbsMag  -10.0  	Type "E0"
	RA 3.478
	Dec -55.71
	Distance 1.075e9
	Radius 5.43e6
}

Galaxy "#Abell 2556"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2556"
	AbsMag  -10.0  	Type "E0"
	RA 23.219
	Dec -21.64
	Distance 1.079e9
	Radius 5.18e6
}

Galaxy "#A623"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A623"
	AbsMag  -10.0  	Type "E0"
	RA 8.094
	Dec -0.94
	Distance 1.086e9
	Radius 4.96e6
}

Galaxy "#A2301"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2301"
	AbsMag  -10.0  	Type "E0"
	RA 18.246
	Dec 69.65
	Distance 1.09e9
	Radius 4.17e6
}

Galaxy "#A272"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A272"
	AbsMag  -10.0  	Type "E0"
	RA 1.922
	Dec 33.94
	Distance 1.093e9
	Radius 4.81e6
}

Galaxy "#A281"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A281"
	AbsMag  -10.0  	Type "E0"
	RA 1.952
	Dec -5.84
	Distance 1.097e9
	Radius 4.65e6
}

Galaxy "#A991"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A991"
	AbsMag  -10.0  	Type "E0"
	RA 10.374
	Dec 18.88
	Distance 1.097e9
	Radius 4.78e6
}

Galaxy "#A858"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A858"
	AbsMag  -10.0  	Type "E0"
	RA 9.724
	Dec 5.89
	Distance 1.098e9
	Radius 4.55e6
}

Galaxy "#A2400"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2400"
	AbsMag  -10.0  	Type "E0"
	RA 21.963
	Dec -11.38
	Distance 1.098e9
	Radius 4.93e6
}

Galaxy "#A1939"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1939"
	AbsMag  -10.0  	Type "E0"
	RA 14.621
	Dec 24.83
	Distance 1.1e9
	Radius 5.02e6
}

Galaxy "#A912"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A912"
	AbsMag  -10.0  	Type "E0"
	RA 10.019
	Dec -0.11
	Distance 1.106e9
	Radius 4.25e6
}

Galaxy "#A3963"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3963"
	AbsMag  -10.0  	Type "E0"
	RA 23.064
	Dec -44.31
	Distance 1.109e9
	Radius 4.41e6
}

Galaxy "#A1609"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1609"
	AbsMag  -10.0  	Type "E0"
	RA 12.774
	Dec 26.43
	Distance 1.11e9
	Radius 4.93e6
}

Galaxy "#A1541"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1541"
	AbsMag  -10.0  	Type "E0"
	RA 12.457
	Dec 8.84
	Distance 1.111e9
	Radius 4.99e6
}

Galaxy "#A278"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A278"
	AbsMag  -10.0  	Type "E0"
	RA 1.955
	Dec 32.23
	Distance 1.116e9
	Radius 4.33e6
}

Galaxy "#A410"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A410"
	AbsMag  -10.0  	Type "E0"
	RA 3.065
	Dec 3.79
	Distance 1.117e9
	Radius 5.31e6
}

Galaxy "#A2142"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2142"
	AbsMag  -10.0  	Type "E0"
	RA 15.971
	Dec 27.22
	Distance 1.119e9
	Radius 5.75e6
}

Galaxy "#A478"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A478"
	AbsMag  -10.0  	Type "E0"
	RA 4.223
	Dec 10.48
	Distance 1.121e9
	Radius 6.06e6
}

Galaxy "#A3330"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3330"
	AbsMag  -10.0  	Type "E0"
	RA 5.245
	Dec -49.06
	Distance 1.124e9
	Radius 4.81e6
}

Galaxy "#A2440"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2440"
	AbsMag  -10.0  	Type "E0"
	RA 22.398
	Dec -1.6
	Distance 1.125e9
	Radius 4.09e6
}

Galaxy "#A1399"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1399"
	AbsMag  -10.0  	Type "E0"
	RA 11.853
	Dec -3.09
	Distance 1.136e9
	Radius 5.6e6
}

Galaxy "#A945"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A945"
	AbsMag  -10.0  	Type "E0"
	RA 10.261
	Dec 69.08
	Distance 1.141e9
	Radius 4.58e6
}

Galaxy "#A2108"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2108"
	AbsMag  -10.0  	Type "E0"
	RA 15.668
	Dec 17.89
	Distance 1.143e9
	Radius 4.58e6
}

Galaxy "#A3040"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3040"
	AbsMag  -10.0  	Type "E0"
	RA 2.669
	Dec -55.42
	Distance 1.148e9
	Radius 5.28e6
}

Galaxy "#A79"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A79"
	AbsMag  -10.0  	Type "E0"
	RA 0.677
	Dec 18.14
	Distance 1.153e9
	Radius 5.38e6
}

Galaxy "#A2178"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2178"
	AbsMag  -10.0  	Type "E0"
	RA 16.358
	Dec 24.65
	Distance 1.154e9
	Radius 4.78e6
}

Galaxy "#AS1022"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1022"
	AbsMag  -10.0  	Type "E0"
	RA 22.422
	Dec -64.25
	Distance 1.163e9
	Radius 2.05e6
}

Galaxy "#A1496"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1496"
	AbsMag  -10.0  	Type "E0"
	RA 12.223
	Dec 59.27
	Distance 1.169e9
	Radius 4.99e6
}

Galaxy "#Abell 2384"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2384"
	AbsMag  -10.0  	Type "E0"
	RA 21.873
	Dec -19.55
	Distance 1.172e9
	Radius 5.36e6
}

Galaxy "#A2048"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2048"
	AbsMag  -10.0  	Type "E0"
	RA 15.255
	Dec 4.38
	Distance 1.174e9
	Radius 5.43e6
}

Galaxy "#A277"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A277"
	AbsMag  -10.0  	Type "E0"
	RA 1.93
	Dec -7.37
	Distance 1.176e9
	Radius 4.75e6
}

Galaxy "#A21"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A21"
	AbsMag  -10.0  	Type "E0"
	RA 0.342
	Dec 28.63
	Distance 1.177e9
	Radius 4.93e6
}

Galaxy "#A3334"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3334"
	AbsMag  -10.0  	Type "E0"
	RA 5.299
	Dec -58.55
	Distance 1.183e9
	Radius 5.6e6
}

Galaxy "#Abell 2528"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2528"
	AbsMag  -10.0  	Type "E0"
	RA 23.093
	Dec -21.4
	Distance 1.186e9
	Radius 5.36e6
}

Galaxy "#A2694"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2694"
	AbsMag  -10.0  	Type "E0"
	RA 0.043
	Dec 8.43
	Distance 1.189e9
	Radius 6.56e6
}

Galaxy "#A1346"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1346"
	AbsMag  -10.0  	Type "E0"
	RA 11.686
	Dec 5.69
	Distance 1.203e9
	Radius 5.02e6
}

Galaxy "#A2244"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2244"
	AbsMag  -10.0  	Type "E0"
	RA 17.045
	Dec 34.05
	Distance 1.203e9
	Radius 5.75e6
}

Galaxy "#A2110"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2110"
	AbsMag  -10.0  	Type "E0"
	RA 15.662
	Dec 30.71
	Distance 1.213e9
	Radius 4.87e6
}

Galaxy "#A2175"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2175"
	AbsMag  -10.0  	Type "E0"
	RA 16.34
	Dec 29.92
	Distance 1.213e9
	Radius 5.07e6
}

Galaxy "#A2700"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2700"
	AbsMag  -10.0  	Type "E0"
	RA 0.065
	Dec 2.06
	Distance 1.213e9
	Radius 5.02e6
}

Galaxy "#A566"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A566"
	AbsMag  -10.0  	Type "E0"
	RA 7.075
	Dec 63.29
	Distance 1.22e9
	Radius 6.47e6
}

Galaxy "#A1859"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1859"
	AbsMag  -10.0  	Type "E0"
	RA 14.086
	Dec 60.1
	Distance 1.225e9
	Radius 4.58e6
}

Galaxy "#A924"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A924"
	AbsMag  -10.0  	Type "E0"
	RA 10.117
	Dec 35.66
	Distance 1.226e9
	Radius 5.43e6
}

Galaxy "#A3827"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3827"
	AbsMag  -10.0  	Type "E0"
	RA 22.029
	Dec -59.94
	Distance 1.23e9
	Radius 5.98e6
}

Galaxy "#A2021"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2021"
	AbsMag  -10.0  	Type "E0"
	RA 15.059
	Dec 23.02
	Distance 1.232e9
	Radius 4.81e6
}

Galaxy "#A190"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A190"
	AbsMag  -10.0  	Type "E0"
	RA 1.395
	Dec -9.86
	Distance 1.256e9
	Radius 4.13e6
}

Galaxy "#Abell 2541"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2541"
	AbsMag  -10.0  	Type "E0"
	RA 23.173
	Dec -22.96
	Distance 1.26e9
	Radius 5.46e6
}

Galaxy "#A1446"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1446"
	AbsMag  -10.0  	Type "E0"
	RA 12.031
	Dec 58.02
	Distance 1.272e9
	Radius 5.66e6
}

Galaxy "#A186"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A186"
	AbsMag  -10.0  	Type "E0"
	RA 1.378
	Dec -10.42
	Distance 1.273e9
	Radius 4.93e6
}

Galaxy "#A84"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A84"
	AbsMag  -10.0  	Type "E0"
	RA 0.697
	Dec 21.41
	Distance 1.274e9
	Radius 5.46e6
}

Galaxy "#A1999"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1999"
	AbsMag  -10.0  	Type "E0"
	RA 14.901
	Dec 54.31
	Distance 1.276e9
	Radius 5.26e6
}

Galaxy "#A403"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A403"
	AbsMag  -10.0  	Type "E0"
	RA 2.987
	Dec 3.5
	Distance 1.277e9
	Radius 5.98e6
}

Galaxy "#A1225"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1225"
	AbsMag  -10.0  	Type "E0"
	RA 11.355
	Dec 53.76
	Distance 1.277e9
	Radius 4.51e6
}

Galaxy "#A1235"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1235"
	AbsMag  -10.0  	Type "E0"
	RA 11.382
	Dec 19.63
	Distance 1.288e9
	Radius 6.39e6
}

Galaxy "#A1559"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1559"
	AbsMag  -10.0  	Type "E0"
	RA 12.551
	Dec 67.11
	Distance 1.288e9
	Radius 4.75e6
}

Galaxy "#A121"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A121"
	AbsMag  -10.0  	Type "E0"
	RA 0.959
	Dec -7.01
	Distance 1.295e9
	Radius 5.23e6
}

Galaxy "#A98"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A98"
	AbsMag  -10.0  	Type "E0"
	RA 0.774
	Dec 20.49
	Distance 1.297e9
	Radius 7.34e6
}

Galaxy "#Abell 458"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 458"
	AbsMag  -10.0  	Type "E0"
	RA 3.763
	Dec -24.28
	Distance 1.297e9
	Radius 5.77e6
}

Galaxy "#A2263"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2263"
	AbsMag  -10.0  	Type "E0"
	RA 17.387
	Dec 26.94
	Distance 1.298e9
	Radius 4.62e6
}

Galaxy "#A23"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A23"
	AbsMag  -10.0  	Type "E0"
	RA 0.363
	Dec -0.89
	Distance 1.3e9
	Radius 4.58e6
}

Galaxy "#A1382"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1382"
	AbsMag  -10.0  	Type "E0"
	RA 11.806
	Dec 71.44
	Distance 1.301e9
	Radius 4.96e6
}

Galaxy "#A2257"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2257"
	AbsMag  -10.0  	Type "E0"
	RA 17.299
	Dec 32.58
	Distance 1.302e9
	Radius 5.07e6
}

Galaxy "#A1674"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1674"
	AbsMag  -10.0  	Type "E0"
	RA 13.059
	Dec 67.5
	Distance 1.303e9
	Radius 7.06e6
}

Galaxy "#Abell 2554"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2554"
	AbsMag  -10.0  	Type "E0"
	RA 23.206
	Dec -21.54
	Distance 1.309e9
	Radius 5.98e6
}

Galaxy "#A1342"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1342"
	AbsMag  -10.0  	Type "E0"
	RA 11.678
	Dec 10.07
	Distance 1.31e9
	Radius 4.84e6
}

Galaxy "#A439"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A439"
	AbsMag  -10.0  	Type "E0"
	RA 3.508
	Dec 24.79
	Distance 1.312e9
	Radius 4.21e6
}

Galaxy "#A1364"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1364"
	AbsMag  -10.0  	Type "E0"
	RA 11.728
	Dec -1.76
	Distance 1.321e9
	Radius 5.41e6
}

Galaxy "#A7"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A7"
	AbsMag  -10.0  	Type "E0"
	RA 0.195
	Dec 32.41
	Distance 1.324e9
	Radius 4.9e6
}

Galaxy "#A2064"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2064"
	AbsMag  -10.0  	Type "E0"
	RA 15.35
	Dec 48.64
	Distance 1.328e9
	Radius 4.29e6
}

Galaxy "#A2471"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2471"
	AbsMag  -10.0  	Type "E0"
	RA 22.697
	Dec 7.26
	Distance 1.33e9
	Radius 5.81e6
}

Galaxy "#A2443"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2443"
	AbsMag  -10.0  	Type "E0"
	RA 22.435
	Dec 17.34
	Distance 1.332e9
	Radius 6.3e6
}

Galaxy "#Abell 88"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 88"
	AbsMag  -10.0  	Type "E0"
	RA 0.716
	Dec -26.06
	Distance 1.339e9
	Radius 4.21e6
}

Galaxy "#Abell 42"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 42"
	AbsMag  -10.0  	Type "E0"
	RA 0.477
	Dec -23.64
	Distance 1.34e9
	Radius 6.7e6
}

Galaxy "#A1345"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1345"
	AbsMag  -10.0  	Type "E0"
	RA 11.687
	Dec 10.69
	Distance 1.35e9
	Radius 5.33e6
}

Galaxy "#A562"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A562"
	AbsMag  -10.0  	Type "E0"
	RA 6.866
	Dec 69.27
	Distance 1.355e9
	Radius 5.309e6
}

Galaxy "#AS84"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS84"
	AbsMag  -10.0  	Type "E0"
	RA 0.822
	Dec -29.53
	Distance 1.355e9
	Radius 2.87e6
}

Galaxy "#Abell 2548"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2548"
	AbsMag  -10.0  	Type "E0"
	RA 23.187
	Dec -20.46
	Distance 1.357e9
	Radius 4.33e6
}

Galaxy "#A1322"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1322"
	AbsMag  -10.0  	Type "E0"
	RA 11.617
	Dec 63.22
	Distance 1.36e9
	Radius 4.58e6
}

Galaxy "#A1840"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1840"
	AbsMag  -10.0  	Type "E0"
	RA 14.025
	Dec 30.58
	Distance 1.36e9
	Radius 4.21e6
}

Galaxy "#A2220"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2220"
	AbsMag  -10.0  	Type "E0"
	RA 16.661
	Dec 53.75
	Distance 1.362e9
	Radius 4.48e6
}

Galaxy "#A43"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A43"
	AbsMag  -10.0  	Type "E0"
	RA 0.482
	Dec 17.58
	Distance 1.372e9
	Radius 4.29e6
}

Galaxy "#A95"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A95"
	AbsMag  -10.0  	Type "E0"
	RA 0.764
	Dec -0.86
	Distance 1.373e9
	Radius 4.81e6
}

Galaxy "#A243"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A243"
	AbsMag  -10.0  	Type "E0"
	RA 1.708
	Dec -10.23
	Distance 1.375e9
	Radius 4.65e6
}

Galaxy "#Abell 2546"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2546"
	AbsMag  -10.0  	Type "E0"
	RA 23.178
	Dec -22.66
	Distance 1.378e9
	Radius 5.1e6
}

Galaxy "#A1227"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1227"
	AbsMag  -10.0  	Type "E0"
	RA 11.359
	Dec 48.03
	Distance 1.379e9
	Radius 6.21e6
}

Galaxy "#A2001"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2001"
	AbsMag  -10.0  	Type "E0"
	RA 14.951
	Dec 22.75
	Distance 1.381e9
	Radius 4.96e6
}

Galaxy "#Abell 2686"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2686"
	AbsMag  -10.0  	Type "E0"
	RA 23.985
	Dec -20.77
	Distance 1.383e9
	Radius 5.07e6
}

Galaxy "#A2762"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2762"
	AbsMag  -10.0  	Type "E0"
	RA 0.324
	Dec -53.54
	Distance 1.383e9
	Radius 4.58e6
}

Galaxy "#A217"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A217"
	AbsMag  -10.0  	Type "E0"
	RA 1.61
	Dec -8.05
	Distance 1.386e9
	Radius 5.15e6
}

Galaxy "#A1372"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1372"
	AbsMag  -10.0  	Type "E0"
	RA 11.758
	Dec 11.52
	Distance 1.386e9
	Radius 5.31e6
}

Galaxy "#A2798"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2798"
	AbsMag  -10.0  	Type "E0"
	RA 0.626
	Dec -28.54
	Distance 1.386e9
	Radius 4.99e6
}

Galaxy "#A2053"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2053"
	AbsMag  -10.0  	Type "E0"
	RA 15.288
	Dec -0.68
	Distance 1.387e9
	Radius 5.43e6
}

Galaxy "#Abell 2339"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2339"
	AbsMag  -10.0  	Type "E0"
	RA 21.349
	Dec -21.45
	Distance 1.388e9
	Radius 3.82e6
}

Galaxy "#Abell 2330"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2330"
	AbsMag  -10.0  	Type "E0"
	RA 20.961
	Dec -22.04
	Distance 1.4e9
	Radius 6.02e6
}

Galaxy "#A2721"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2721"
	AbsMag  -10.0  	Type "E0"
	RA 0.103
	Dec -34.72
	Distance 1.402e9
	Radius 7.43e6
}

Galaxy "#A2730"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2730"
	AbsMag  -10.0  	Type "E0"
	RA 0.165
	Dec -35.69
	Distance 1.402e9
	Radius 5.53e6
}

Galaxy "#A2083"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2083"
	AbsMag  -10.0  	Type "E0"
	RA 15.491
	Dec 30.75
	Distance 1.405e9
	Radius 5.04e6
}

Galaxy "#A2703"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2703"
	AbsMag  -10.0  	Type "E0"
	RA 0.089
	Dec 16.1
	Distance 1.406e9
	Radius 4.62e6
}

Galaxy "#A1738"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1738"
	AbsMag  -10.0  	Type "E0"
	RA 13.419
	Dec 57.61
	Distance 1.409e9
	Radius 5.66e6
}

Galaxy "#A2252"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2252"
	AbsMag  -10.0  	Type "E0"
	RA 17.231
	Dec 49.39
	Distance 1.41e9
	Radius 5.126e6
}

Galaxy "#A1980"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1980"
	AbsMag  -10.0  	Type "E0"
	RA 14.859
	Dec 22.66
	Distance 1.416e9
	Radius 4.75e6
}

Galaxy "#A166"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A166"
	AbsMag  -10.0  	Type "E0"
	RA 1.243
	Dec -16.27
	Distance 1.42e9
	Radius 5.46e6
}

Galaxy "#A216"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A216"
	AbsMag  -10.0  	Type "E0"
	RA 1.612
	Dec -6.41
	Distance 1.423e9
	Radius 5.31e6
}

Galaxy "#A733"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A733"
	AbsMag  -10.0  	Type "E0"
	RA 9.022
	Dec 55.62
	Distance 1.424e9
	Radius 5.15e6
}

Galaxy "#Abell 389"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 389"
	AbsMag  -10.0  	Type "E0"
	RA 2.856
	Dec -24.94
	Distance 1.425e9
	Radius 6.57e6
}

Galaxy "#A1988"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1988"
	AbsMag  -10.0  	Type "E0"
	RA 14.891
	Dec 20.78
	Distance 1.425e9
	Radius 4.44e6
}

Galaxy "#A2069"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2069"
	AbsMag  -10.0  	Type "E0"
	RA 15.399
	Dec 29.89
	Distance 1.425e9
	Radius 5.92e6
}

Galaxy "#A2356"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2356"
	AbsMag  -10.0  	Type "E0"
	RA 21.596
	Dec 0.12
	Distance 1.426e9
	Radius 5.75e6
}

Galaxy "#A923"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A923"
	AbsMag  -10.0  	Type "E0"
	RA 10.109
	Dec 25.91
	Distance 1.427e9
	Radius 4.75e6
}

Galaxy "#A2036"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2036"
	AbsMag  -10.0  	Type "E0"
	RA 15.191
	Dec 18.06
	Distance 1.428e9
	Radius 4.37e6
}

Galaxy "#A2006"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2006"
	AbsMag  -10.0  	Type "E0"
	RA 14.993
	Dec 19.67
	Distance 1.43e9
	Radius 4.99e6
}

Galaxy "#A1976"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1976"
	AbsMag  -10.0  	Type "E0"
	RA 14.839
	Dec 20.96
	Distance 1.435e9
	Radius 4.84e6
}

Galaxy "#A1354"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1354"
	AbsMag  -10.0  	Type "E0"
	RA 11.703
	Dec 10.16
	Distance 1.446e9
	Radius 4.96e6
}

Galaxy "#A1986"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1986"
	AbsMag  -10.0  	Type "E0"
	RA 14.886
	Dec 21.91
	Distance 1.45e9
	Radius 5.23e6
}

Galaxy "#A2050"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2050"
	AbsMag  -10.0  	Type "E0"
	RA 15.273
	Dec 0.1
	Distance 1.451e9
	Radius 4.75e6
}

Galaxy "#A1972"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1972"
	AbsMag  -10.0  	Type "E0"
	RA 14.805
	Dec 23.94
	Distance 1.458e9
	Radius 4.33e6
}

Galaxy "#A2584"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2584"
	AbsMag  -10.0  	Type "E0"
	RA 23.368
	Dec 27.56
	Distance 1.466e9
	Radius 4.62e6
}

Galaxy "#A3593"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3593"
	AbsMag  -10.0  	Type "E0"
	RA 14.32
	Dec -19.48
	Distance 1.466e9
	Radius 4.09e6
}

Galaxy "#Abell 2347"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2347"
	AbsMag  -10.0  	Type "E0"
	RA 21.494
	Dec -22.26
	Distance 1.466e9
	Radius 4.21e6
}

Galaxy "#A3136"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3136"
	AbsMag  -10.0  	Type "E0"
	RA 3.537
	Dec -71.83
	Distance 1.474e9
	Radius 5.26e6
}

Galaxy "#Abell 15"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 15"
	AbsMag  -10.0  	Type "E0"
	RA 0.252
	Dec -26.04
	Distance 1.482e9
	Radius 4.81e6
}

Galaxy "#A3854"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3854"
	AbsMag  -10.0  	Type "E0"
	RA 22.295
	Dec -35.72
	Distance 1.487e9
	Radius 6.52e6
}

Galaxy "#A1884"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1884"
	AbsMag  -10.0  	Type "E0"
	RA 14.197
	Dec 61.38
	Distance 1.494e9
	Radius 4.58e6
}

Galaxy "#A188"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A188"
	AbsMag  -10.0  	Type "E0"
	RA 1.379
	Dec -0.89
	Distance 1.505e9
	Radius 4.96e6
}

Galaxy "#A1984"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1984"
	AbsMag  -10.0  	Type "E0"
	RA 14.873
	Dec 27.95
	Distance 1.507e9
	Radius 5.84e6
}

Galaxy "#A2496"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2496"
	AbsMag  -10.0  	Type "E0"
	RA 22.849
	Dec -16.4
	Distance 1.509e9
	Radius 6.06e6
}

Galaxy "#A1123"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1123"
	AbsMag  -10.0  	Type "E0"
	RA 10.945
	Dec 75.52
	Distance 1.511e9
	Radius 6.13e6
}

Galaxy "#A784"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A784"
	AbsMag  -10.0  	Type "E0"
	RA 9.375
	Dec 54.97
	Distance 1.512e9
	Radius 5.15e6
}

Galaxy "#A786"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A786"
	AbsMag  -10.0  	Type "E0"
	RA 9.481
	Dec 74.8
	Distance 1.518e9
	Radius 4.58e6
}

Galaxy "#A1877"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1877"
	AbsMag  -10.0  	Type "E0"
	RA 14.174
	Dec 59.78
	Distance 1.518e9
	Radius 5.33e6
}

Galaxy "#A2355"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2355"
	AbsMag  -10.0  	Type "E0"
	RA 21.589
	Dec 1.39
	Distance 1.521e9
	Radius 6.21e6
}

Galaxy "#A655"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A655"
	AbsMag  -10.0  	Type "E0"
	RA 8.422
	Dec 47.12
	Distance 1.523e9
	Radius 6.72e6
}

Galaxy "#A1"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1"
	AbsMag  -10.0  	Type "E0"
	RA 0.126
	Dec 16.51
	Distance 1.527e9
	Radius 4.78e6
}

Galaxy "#A2005"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2005"
	AbsMag  -10.0  	Type "E0"
	RA 14.979
	Dec 27.82
	Distance 1.536e9
	Radius 6.08e6
}

Galaxy "#A1264"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1264"
	AbsMag  -10.0  	Type "E0"
	RA 11.453
	Dec 17.14
	Distance 1.548e9
	Radius 5.96e6
}

Galaxy "#A1990"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1990"
	AbsMag  -10.0  	Type "E0"
	RA 14.896
	Dec 28.08
	Distance 1.55e9
	Radius 6.89e6
}

Galaxy "#Abell 2565"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2565"
	AbsMag  -10.0  	Type "E0"
	RA 23.263
	Dec -21.18
	Distance 1.552e9
	Radius 5.18e6
}

Galaxy "#A259"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A259"
	AbsMag  -10.0  	Type "E0"
	RA 1.837
	Dec -11.99
	Distance 1.555e9
	Radius 4.05e6
}

Galaxy "#A226"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A226"
	AbsMag  -10.0  	Type "E0"
	RA 1.649
	Dec -10.25
	Distance 1.565e9
	Radius 5.43e6
}

Galaxy "#A2165"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2165"
	AbsMag  -10.0  	Type "E0"
	RA 16.236
	Dec 26.67
	Distance 1.569e9
	Radius 4.17e6
}

Galaxy "#A175"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A175"
	AbsMag  -10.0  	Type "E0"
	RA 1.326
	Dec 14.88
	Distance 1.57e9
	Radius 5.64e6
}

Galaxy "#A228"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A228"
	AbsMag  -10.0  	Type "E0"
	RA 1.653
	Dec -10.05
	Distance 1.573e9
	Radius 4.13e6
}

Galaxy "#A274"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A274"
	AbsMag  -10.0  	Type "E0"
	RA 1.912
	Dec -6.27
	Distance 1.573e9
	Radius 6.69e6
}

Galaxy "#A1278"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1278"
	AbsMag  -10.0  	Type "E0"
	RA 11.503
	Dec 20.47
	Distance 1.574e9
	Radius 6.86e6
}

Galaxy "#Abell 2540"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2540"
	AbsMag  -10.0  	Type "E0"
	RA 23.158
	Dec -22.16
	Distance 1.582e9
	Radius 4.62e6
}

Galaxy "#A646"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A646"
	AbsMag  -10.0  	Type "E0"
	RA 8.369
	Dec 47.11
	Distance 1.589e9
	Radius 4.68e6
}

Galaxy "#A1920"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1920"
	AbsMag  -10.0  	Type "E0"
	RA 14.455
	Dec 55.78
	Distance 1.597e9
	Radius 6.04e6
}

Galaxy "#A1930"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1930"
	AbsMag  -10.0  	Type "E0"
	RA 14.544
	Dec 31.61
	Distance 1.6e9
	Radius 5.04e6
}

Galaxy "#A1373"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1373"
	AbsMag  -10.0  	Type "E0"
	RA 11.757
	Dec -2.39
	Distance 1.601e9
	Radius 5.86e6
}

Galaxy "#A1343"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1343"
	AbsMag  -10.0  	Type "E0"
	RA 11.689
	Dec 60.66
	Distance 1.606e9
	Radius 4.09e6
}

Galaxy "#A468"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A468"
	AbsMag  -10.0  	Type "E0"
	RA 3.879
	Dec 21.41
	Distance 1.614e9
	Radius 4.17e6
}

Galaxy "#A762"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A762"
	AbsMag  -10.0  	Type "E0"
	RA 9.318
	Dec 74.29
	Distance 1.622e9
	Radius 4.09e6
}

Galaxy "#A2196"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2196"
	AbsMag  -10.0  	Type "E0"
	RA 16.456
	Dec 41.49
	Distance 1.622e9
	Radius 4.62e6
}

Galaxy "#A24"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A24"
	AbsMag  -10.0  	Type "E0"
	RA 0.375
	Dec 23.29
	Distance 1.628e9
	Radius 6.47e6
}

Galaxy "#A1437"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1437"
	AbsMag  -10.0  	Type "E0"
	RA 12.008
	Dec 3.34
	Distance 1.63e9
	Radius 6.9e6
}

Galaxy "#A96"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A96"
	AbsMag  -10.0  	Type "E0"
	RA 0.774
	Dec 39.51
	Distance 1.635e9
	Radius 5.07e6
}

Galaxy "#A2158"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2158"
	AbsMag  -10.0  	Type "E0"
	RA 16.137
	Dec 43
	Distance 1.641e9
	Radius 4.58e6
}

Galaxy "#A180"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A180"
	AbsMag  -10.0  	Type "E0"
	RA 1.365
	Dec 3.01
	Distance 1.642e9
	Radius 4.13e6
}

Galaxy "#Abell 2518"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2518"
	AbsMag  -10.0  	Type "E0"
	RA 23.013
	Dec -24.13
	Distance 1.643e9
	Radius 4.51e6
}

Galaxy "#A787"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A787"
	AbsMag  -10.0  	Type "E0"
	RA 9.476
	Dec 74.4
	Distance 1.644e9
	Radius 6.1e6
}

Galaxy "#A1921"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1921"
	AbsMag  -10.0  	Type "E0"
	RA 14.488
	Dec 23.09
	Distance 1.644e9
	Radius 5.13e6
}

Galaxy "#A2211"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2211"
	AbsMag  -10.0  	Type "E0"
	RA 16.568
	Dec 40.93
	Distance 1.648e9
	Radius 4.87e6
}

Galaxy "#A795"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A795"
	AbsMag  -10.0  	Type "E0"
	RA 9.401
	Dec 14.17
	Distance 1.65e9
	Radius 6.86e6
}

Galaxy "#Abell 2521"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2521"
	AbsMag  -10.0  	Type "E0"
	RA 23.036
	Dec -22.03
	Distance 1.652e9
	Radius 5.66e6
}

Galaxy "#A2179"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2179"
	AbsMag  -10.0  	Type "E0"
	RA 16.337
	Dec 42.42
	Distance 1.653e9
	Radius 4.81e6
}

Galaxy "#A1132"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1132"
	AbsMag  -10.0  	Type "E0"
	RA 10.972
	Dec 56.78
	Distance 1.657e9
	Radius 5.41e6
}

Galaxy "#A2183"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2183"
	AbsMag  -10.0  	Type "E0"
	RA 16.359
	Dec 42.72
	Distance 1.659e9
	Radius 4.93e6
}

Galaxy "#A1524"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1524"
	AbsMag  -10.0  	Type "E0"
	RA 12.363
	Dec 7.84
	Distance 1.663e9
	Radius 6.04e6
}

Galaxy "#A629"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A629"
	AbsMag  -10.0  	Type "E0"
	RA 8.25
	Dec 66.43
	Distance 1.676e9
	Radius 5.5e6
}

Galaxy "#A2240"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2240"
	AbsMag  -10.0  	Type "E0"
	RA 16.901
	Dec 66.74
	Distance 1.676e9
	Radius 7.06e6
}

Galaxy "#A1392"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1392"
	AbsMag  -10.0  	Type "E0"
	RA 11.843
	Dec -0.58
	Distance 1.678e9
	Radius 4.62e6
}

Galaxy "#A1937"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1937"
	AbsMag  -10.0  	Type "E0"
	RA 14.574
	Dec 58.27
	Distance 1.678e9
	Radius 5.96e6
}

Galaxy "#Abell 2555"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2555"
	AbsMag  -10.0  	Type "E0"
	RA 23.214
	Dec -22.21
	Distance 1.681e9
	Radius 5.13e6
}

Galaxy "#A1936"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1936"
	AbsMag  -10.0  	Type "E0"
	RA 14.575
	Dec 54.82
	Distance 1.683e9
	Radius 5.28e6
}

Galaxy "#A2172"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2172"
	AbsMag  -10.0  	Type "E0"
	RA 16.279
	Dec 42.39
	Distance 1.684e9
	Radius 5.28e6
}

Galaxy "#A1073"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1073"
	AbsMag  -10.0  	Type "E0"
	RA 10.707
	Dec 36.64
	Distance 1.687e9
	Radius 5.6e6
}

Galaxy "#A1940"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1940"
	AbsMag  -10.0  	Type "E0"
	RA 14.591
	Dec 55.15
	Distance 1.694e9
	Radius 6.52e6
}

Galaxy "#Abell 2568"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2568"
	AbsMag  -10.0  	Type "E0"
	RA 23.286
	Dec -22.19
	Distance 1.696e9
	Radius 4.48e6
}

Galaxy "#A516"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A516"
	AbsMag  -10.0  	Type "E0"
	RA 4.835
	Dec -8.81
	Distance 1.706e9
	Radius 5.07e6
}

Galaxy "#A882"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A882"
	AbsMag  -10.0  	Type "E0"
	RA 9.854
	Dec 8.25
	Distance 1.707e9
	Radius 4.68e6
}

Galaxy "#Abell 1146"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 1146"
	AbsMag  -10.0  	Type "E0"
	RA 11.021
	Dec -22.72
	Distance 1.71e9
	Radius 7.02e6
}

Galaxy "#A1880"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1880"
	AbsMag  -10.0  	Type "E0"
	RA 14.22
	Dec 22.4
	Distance 1.713e9
	Radius 5.23e6
}

Galaxy "#A1918"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1918"
	AbsMag  -10.0  	Type "E0"
	RA 14.419
	Dec 63.16
	Distance 1.715e9
	Radius 6.72e6
}

Galaxy "#A951"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A951"
	AbsMag  -10.0  	Type "E0"
	RA 10.232
	Dec 34.72
	Distance 1.729e9
	Radius 4.81e6
}

Galaxy "#A1413"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1413"
	AbsMag  -10.0  	Type "E0"
	RA 11.923
	Dec 23.37
	Distance 1.729e9
	Radius 7.48e6
}

Galaxy "#A1495"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1495"
	AbsMag  -10.0  	Type "E0"
	RA 12.224
	Dec 29.24
	Distance 1.731e9
	Radius 6.41e6
}

Galaxy "#Abell 22"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 22"
	AbsMag  -10.0  	Type "E0"
	RA 0.342
	Dec -25.72
	Distance 1.734e9
	Radius 7.429e6
}

Galaxy "#A1283"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1283"
	AbsMag  -10.0  	Type "E0"
	RA 11.521
	Dec 60.76
	Distance 1.736e9
	Radius 4.87e6
}

Galaxy "#A1396"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1396"
	AbsMag  -10.0  	Type "E0"
	RA 11.854
	Dec 54.86
	Distance 1.744e9
	Radius 4.51e6
}

Galaxy "#Abell 2344"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2344"
	AbsMag  -10.0  	Type "E0"
	RA 21.429
	Dec -20.78
	Distance 1.751e9
	Radius 4.81e6
}

Galaxy "#A2210"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2210"
	AbsMag  -10.0  	Type "E0"
	RA 16.579
	Dec 5.48
	Distance 1.771e9
	Radius 4.75e6
}

Galaxy "#Abell 2328"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2328"
	AbsMag  -10.0  	Type "E0"
	RA 20.804
	Dec -17.81
	Distance 1.777e9
	Radius 4.62e6
}

Galaxy "#A508"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A508"
	AbsMag  -10.0  	Type "E0"
	RA 4.765
	Dec 2.01
	Distance 1.787e9
	Radius 5.66e6
}

Galaxy "#A513"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A513"
	AbsMag  -10.0  	Type "E0"
	RA 4.803
	Dec -9.71
	Distance 1.8e9
	Radius 4.09e6
}

Galaxy "#Abell 2547"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2547"
	AbsMag  -10.0  	Type "E0"
	RA 23.181
	Dec -21.14
	Distance 1.801e9
	Radius 6.47e6
}

Galaxy "#A46"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A46"
	AbsMag  -10.0  	Type "E0"
	RA 0.504
	Dec -12.87
	Distance 1.81e9
	Radius 5.5e6
}

Galaxy "#A2224"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2224"
	AbsMag  -10.0  	Type "E0"
	RA 16.723
	Dec 13.34
	Distance 1.815e9
	Radius 6.66e6
}

Galaxy "#A1872"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1872"
	AbsMag  -10.0  	Type "E0"
	RA 14.151
	Dec 61.95
	Distance 1.819e9
	Radius 4.37e6
}

Galaxy "#A2012"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2012"
	AbsMag  -10.0  	Type "E0"
	RA 15.031
	Dec 16.52
	Distance 1.822e9
	Radius 4.84e6
}

Galaxy "#A2235"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2235"
	AbsMag  -10.0  	Type "E0"
	RA 16.916
	Dec 40.02
	Distance 1.822e9
	Radius 5.38e6
}

Galaxy "#Abell 140"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 140"
	AbsMag  -10.0  	Type "E0"
	RA 1.075
	Dec -23.98
	Distance 1.832e9
	Radius 5.53e6
}

Galaxy "#A2204"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2204"
	AbsMag  -10.0  	Type "E0"
	RA 16.546
	Dec 5.58
	Distance 1.836e9
	Radius 6.57e6
}

Galaxy "#A868"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A868"
	AbsMag  -10.0  	Type "E0"
	RA 9.758
	Dec -8.65
	Distance 1.843e9
	Radius 7.35e6
}

Galaxy "#A2009"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2009"
	AbsMag  -10.0  	Type "E0"
	RA 15.004
	Dec 21.37
	Distance 1.843e9
	Radius 5.21e6
}

Galaxy "#A2100"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2100"
	AbsMag  -10.0  	Type "E0"
	RA 15.606
	Dec 37.64
	Distance 1.847e9
	Radius 6.66e6
}

Galaxy "#A1360"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1360"
	AbsMag  -10.0  	Type "E0"
	RA 11.718
	Dec 11.02
	Distance 1.849e9
	Radius 5.21e6
}

Galaxy "#A545"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A545"
	AbsMag  -10.0  	Type "E0"
	RA 5.539
	Dec -11.53
	Distance 1.854e9
	Radius 7.94e6
}

Galaxy "#Abell 2550"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2550"
	AbsMag  -10.0  	Type "E0"
	RA 23.193
	Dec -21.78
	Distance 1.858e9
	Radius 5.64e6
}

Galaxy "#A204"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A204"
	AbsMag  -10.0  	Type "E0"
	RA 1.477
	Dec -6.79
	Distance 1.873e9
	Radius 4.9e6
}

Galaxy "#A506"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A506"
	AbsMag  -10.0  	Type "E0"
	RA 4.721
	Dec -9.71
	Distance 1.878e9
	Radius 5.73e6
}

Galaxy "#A136"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A136"
	AbsMag  -10.0  	Type "E0"
	RA 1.069
	Dec 25.07
	Distance 1.887e9
	Radius 5.96e6
}

Galaxy "#A1081"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1081"
	AbsMag  -10.0  	Type "E0"
	RA 10.747
	Dec 35.57
	Distance 1.907e9
	Radius 5.62e6
}

Galaxy "#A31"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A31"
	AbsMag  -10.0  	Type "E0"
	RA 0.452
	Dec 22.63
	Distance 1.916e9
	Radius 5.77e6
}

Galaxy "#A2213"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2213"
	AbsMag  -10.0  	Type "E0"
	RA 16.609
	Dec 41.28
	Distance 1.917e9
	Radius 5.43e6
}

Galaxy "#A588"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A588"
	AbsMag  -10.0  	Type "E0"
	RA 7.649
	Dec 69.95
	Distance 1.921e9
	Radius 5.5e6
}

Galaxy "#Abell 2542"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2542"
	AbsMag  -10.0  	Type "E0"
	RA 23.168
	Dec -24.5
	Distance 1.924e9
	Radius 4.55e6
}

Galaxy "#A1548"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1548"
	AbsMag  -10.0  	Type "E0"
	RA 12.483
	Dec 19.42
	Distance 1.933e9
	Radius 6.92e6
}

Galaxy "#AS996"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS996"
	AbsMag  -10.0  	Type "E0"
	RA 22.155
	Dec -59.67
	Distance 1.933e9
	Radius 5.81e6
}

Galaxy "#A1101"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1101"
	AbsMag  -10.0  	Type "E0"
	RA 10.828
	Dec 44.35
	Distance 1.936e9
	Radius 5.75e6
}

Galaxy "#A224"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A224"
	AbsMag  -10.0  	Type "E0"
	RA 1.639
	Dec -6.95
	Distance 1.939e9
	Radius 5.43e6
}

Galaxy "#A750"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A750"
	AbsMag  -10.0  	Type "E0"
	RA 9.152
	Dec 11.03
	Distance 1.943e9
	Radius 6.72e6
}

Galaxy "#A1170"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1170"
	AbsMag  -10.0  	Type "E0"
	RA 11.12
	Dec 8.01
	Distance 1.943e9
	Radius 6.06e6
}

Galaxy "#A293"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A293"
	AbsMag  -10.0  	Type "E0"
	RA 2.033
	Dec 3.77
	Distance 1.955e9
	Radius 5.71e6
}

Galaxy "#A1401"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1401"
	AbsMag  -10.0  	Type "E0"
	RA 11.868
	Dec 37.27
	Distance 1.973e9
	Radius 6.89e6
}

Galaxy "#A1667"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1667"
	AbsMag  -10.0  	Type "E0"
	RA 13.055
	Dec 31.82
	Distance 1.973e9
	Radius 5.94e6
}

Galaxy "#A1553"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1553"
	AbsMag  -10.0  	Type "E0"
	RA 12.514
	Dec 10.57
	Distance 1.978e9
	Radius 5.98e6
}

Galaxy "#A1234"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1234"
	AbsMag  -10.0  	Type "E0"
	RA 11.374
	Dec 21.39
	Distance 1.99e9
	Radius 5.73e6
}

Galaxy "#A1497"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1497"
	AbsMag  -10.0  	Type "E0"
	RA 12.235
	Dec 26.66
	Distance 1.996e9
	Radius 6.0e6
}

Galaxy "#A1661"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1661"
	AbsMag  -10.0  	Type "E0"
	RA 13.03
	Dec 29.08
	Distance 1.998e9
	Radius 5.92e6
}

Galaxy "#A2266"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2266"
	AbsMag  -10.0  	Type "E0"
	RA 17.411
	Dec 32.11
	Distance 1.998e9
	Radius 5.62e6
}

Galaxy "#A913"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A913"
	AbsMag  -10.0  	Type "E0"
	RA 10.043
	Dec 20.47
	Distance 2.003e9
	Radius 5.18e6
}

Galaxy "#A1232"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1232"
	AbsMag  -10.0  	Type "E0"
	RA 11.369
	Dec 17.89
	Distance 2.004e9
	Radius 5.31e6
}

Galaxy "#A1759"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1759"
	AbsMag  -10.0  	Type "E0"
	RA 13.567
	Dec 20.24
	Distance 2.008e9
	Radius 6.56e6
}

Galaxy "#A3888"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3888"
	AbsMag  -10.0  	Type "E0"
	RA 22.573
	Dec -37.72
	Distance 2.008e9
	Radius 6.11e6
}

Galaxy "#A1979"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1979"
	AbsMag  -10.0  	Type "E0"
	RA 14.85
	Dec 31.28
	Distance 2.016e9
	Radius 6.13e6
}

Galaxy "#A1201"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1201"
	AbsMag  -10.0  	Type "E0"
	RA 11.217
	Dec 13.43
	Distance 2.017e9
	Radius 6.04e6
}

Galaxy "#A1774"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1774"
	AbsMag  -10.0  	Type "E0"
	RA 13.686
	Dec 40.01
	Distance 2.02e9
	Radius 5.57e6
}

Galaxy "#A2163"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2163"
	AbsMag  -10.0  	Type "E0"
	RA 16.259
	Dec -6.12
	Distance 2.028e9
	Radius 6.34e6
}

Galaxy "#A1679"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1679"
	AbsMag  -10.0  	Type "E0"
	RA 13.109
	Dec 31.8
	Distance 2.029e9
	Radius 6.26e6
}

Galaxy "#A586"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A586"
	AbsMag  -10.0  	Type "E0"
	RA 7.538
	Dec 31.63
	Distance 2.041e9
	Radius 7.4e6
}

# Abell 2218, second-richest cluster in the survey.
Galaxy "#A2218"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2218"
	AbsMag  -10.0  	Type "E0"
	RA 16.598
	Dec 66.22
	Distance 2.041e9
	Radius 7.7e6
}

Galaxy "#A2320"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2320"
	AbsMag  -10.0  	Type "E0"
	RA 19.275
	Dec 70.99
	Distance 2.041e9
	Radius 5.66e6
}

Galaxy "#A1760"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1760"
	AbsMag  -10.0  	Type "E0"
	RA 13.568
	Dec 20.21
	Distance 2.042e9
	Radius 7.11e6
}

Galaxy "#A1914"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1914"
	AbsMag  -10.0  	Type "E0"
	RA 14.434
	Dec 37.83
	Distance 2.043e9
	Radius 6.08e6
}

Galaxy "#AS222"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS222"
	AbsMag  -10.0  	Type "E0"
	RA 2.097
	Dec -50.8
	Distance 2.047e9
	Radius 3.66e6
}

Galaxy "#A234"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A234"
	AbsMag  -10.0  	Type "E0"
	RA 1.684
	Dec 18.92
	Distance 2.064e9
	Radius 5.46e6
}

Galaxy "#Abell 2539"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2539"
	AbsMag  -10.0  	Type "E0"
	RA 23.146
	Dec -21.53
	Distance 2.068e9
	Radius 4.81e6
}

Galaxy "#Abell 2531"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2531"
	AbsMag  -10.0  	Type "E0"
	RA 23.115
	Dec -21.68
	Distance 2.074e9
	Radius 5.04e6
}

Galaxy "#A1773"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1773"
	AbsMag  -10.0  	Type "E0"
	RA 13.703
	Dec 2.25
	Distance 2.109e9
	Radius 5.21e6
}

Galaxy "#A1359"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1359"
	AbsMag  -10.0  	Type "E0"
	RA 11.725
	Dec 61.66
	Distance 2.12e9
	Radius 4.0e6
}

Galaxy "#A2623"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2623"
	AbsMag  -10.0  	Type "E0"
	RA 23.584
	Dec 5.61
	Distance 2.121e9
	Radius 6.72e6
}

Galaxy "#A518"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A518"
	AbsMag  -10.0  	Type "E0"
	RA 4.856
	Dec -10.72
	Distance 2.142e9
	Radius 5.69e6
}

Galaxy "#A1689"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1689"
	AbsMag  -10.0  	Type "E0"
	RA 13.193
	Dec -1.37
	Distance 2.149e9
	Radius 7.87e6
}

Galaxy "#A1954"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1954"
	AbsMag  -10.0  	Type "E0"
	RA 14.701
	Dec 28.52
	Distance 2.149e9
	Radius 6.35e6
}

Galaxy "#A2008"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2008"
	AbsMag  -10.0  	Type "E0"
	RA 15.001
	Dec 23.14
	Distance 2.149e9
	Radius 5.84e6
}

# Abell 665, richest cluster in the survey.
Galaxy "#A665"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A665"
	AbsMag  -10.0  	Type "E0"
	RA 8.513
	Dec 65.88
	Distance 2.155e9
	Radius 8.82e6
}

Galaxy "#A873"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A873"
	AbsMag  -10.0  	Type "E0"
	RA 9.879
	Dec 71.3
	Distance 2.16e9
	Radius 6.57e6
}

Galaxy "#A2187"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2187"
	AbsMag  -10.0  	Type "E0"
	RA 16.405
	Dec 41.25
	Distance 2.165e9
	Radius 4.71e6
}

Galaxy "#A1697"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1697"
	AbsMag  -10.0  	Type "E0"
	RA 13.215
	Dec 46.25
	Distance 2.169e9
	Radius 5.64e6
}

Galaxy "#A2283"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2283"
	AbsMag  -10.0  	Type "E0"
	RA 17.741
	Dec 69.65
	Distance 2.17e9
	Radius 5.18e6
}

Galaxy "#A1677"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1677"
	AbsMag  -10.0  	Type "E0"
	RA 13.098
	Dec 30.9
	Distance 2.172e9
	Radius 6.21e6
}

Galaxy "#A2616"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2616"
	AbsMag  -10.0  	Type "E0"
	RA 23.554
	Dec 5.61
	Distance 2.172e9
	Radius 5.86e6
}

Galaxy "#A1504"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1504"
	AbsMag  -10.0  	Type "E0"
	RA 12.255
	Dec 27.52
	Distance 2.177e9
	Radius 5.94e6
}

Galaxy "#A1675"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1675"
	AbsMag  -10.0  	Type "E0"
	RA 13.087
	Dec 34.55
	Distance 2.181e9
	Radius 4.75e6
}

Galaxy "#A2658"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2658"
	AbsMag  -10.0  	Type "E0"
	RA 23.75
	Dec -12.31
	Distance 2.192e9
	Radius 6.73e6
}

Galaxy "#A1889"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1889"
	AbsMag  -10.0  	Type "E0"
	RA 14.278
	Dec 30.72
	Distance 2.202e9
	Radius 6.21e6
}

Galaxy "#A2632"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2632"
	AbsMag  -10.0  	Type "E0"
	RA 23.63
	Dec -9.22
	Distance 2.202e9
	Radius 6.75e6
}

Galaxy "#A2192"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2192"
	AbsMag  -10.0  	Type "E0"
	RA 16.444
	Dec 42.67
	Distance 2.211e9
	Radius 5.1e6
}

Galaxy "#A1763"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1763"
	AbsMag  -10.0  	Type "E0"
	RA 13.588
	Dec 40.96
	Distance 2.213e9
	Radius 6.87e6
}

Galaxy "#A232"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A232"
	AbsMag  -10.0  	Type "E0"
	RA 1.668
	Dec -10.36
	Distance 2.217e9
	Radius 5.33e6
}

Galaxy "#A236"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A236"
	AbsMag  -10.0  	Type "E0"
	RA 1.675
	Dec -11.85
	Distance 2.217e9
	Radius 4.99e6
}

Galaxy "#A1960"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1960"
	AbsMag  -10.0  	Type "E0"
	RA 14.742
	Dec 19.34
	Distance 2.219e9
	Radius 4.84e6
}

Galaxy "#A125"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A125"
	AbsMag  -10.0  	Type "E0"
	RA 1.002
	Dec 14.27
	Distance 2.224e9
	Radius 5.21e6
}

Galaxy "#A1562"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1562"
	AbsMag  -10.0  	Type "E0"
	RA 12.571
	Dec 41.17
	Distance 2.245e9
	Radius 5.48e6
}

Galaxy "#A1911"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1911"
	AbsMag  -10.0  	Type "E0"
	RA 14.407
	Dec 38.96
	Distance 2.259e9
	Radius 5.55e6
}

Galaxy "#A801"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A801"
	AbsMag  -10.0  	Type "E0"
	RA 9.467
	Dec 20.57
	Distance 2.264e9
	Radius 5.57e6
}

Galaxy "#A2646"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2646"
	AbsMag  -10.0  	Type "E0"
	RA 23.69
	Dec -10.01
	Distance 2.277e9
	Radius 6.61e6
}

Galaxy "#A652"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A652"
	AbsMag  -10.0  	Type "E0"
	RA 8.429
	Dec 56.04
	Distance 2.285e9
	Radius 4.37e6
}

Galaxy "#A3783"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3783"
	AbsMag  -10.0  	Type "E0"
	RA 21.567
	Dec -42.64
	Distance 2.303e9
	Radius 6.32e6
}

Galaxy "#A1632"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1632"
	AbsMag  -10.0  	Type "E0"
	RA 12.884
	Dec 28.81
	Distance 2.311e9
	Radius 5.55e6
}

Galaxy "#A1685"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1685"
	AbsMag  -10.0  	Type "E0"
	RA 13.147
	Dec 34.75
	Distance 2.319e9
	Radius 4.55e6
}

Galaxy "#A115"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A115"
	AbsMag  -10.0  	Type "E0"
	RA 0.933
	Dec 26.32
	Distance 2.32e9
	Radius 7.19e6
}

Galaxy "#Abell 2536"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2536"
	AbsMag  -10.0  	Type "E0"
	RA 23.129
	Dec -22.46
	Distance 2.32e9
	Radius 4.99e6
}

Galaxy "#Abell 2534"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2534"
	AbsMag  -10.0  	Type "E0"
	RA 23.128
	Dec -22.71
	Distance 2.325e9
	Radius 6.46e6
}

Galaxy "#A1643"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1643"
	AbsMag  -10.0  	Type "E0"
	RA 12.932
	Dec 44.08
	Distance 2.331e9
	Radius 4.75e6
}

Galaxy "#A1514"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1514"
	AbsMag  -10.0  	Type "E0"
	RA 12.299
	Dec 20.66
	Distance 2.345e9
	Radius 6.56e6
}

Galaxy "#A1094"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1094"
	AbsMag  -10.0  	Type "E0"
	RA 10.793
	Dec 27.52
	Distance 2.355e9
	Radius 5.62e6
}

Galaxy "#A520"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A520"
	AbsMag  -10.0  	Type "E0"
	RA 4.905
	Dec 2.95
	Distance 2.382e9
	Radius 7.35e6
}

Galaxy "#A732"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A732"
	AbsMag  -10.0  	Type "E0"
	RA 8.965
	Dec 3.17
	Distance 2.382e9
	Radius 5.18e6
}

Galaxy "#A910"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A910"
	AbsMag  -10.0  	Type "E0"
	RA 10.05
	Dec 67.16
	Distance 2.408e9
	Radius 7.8e6
}

Galaxy "#A209"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A209"
	AbsMag  -10.0  	Type "E0"
	RA 1.533
	Dec -13.58
	Distance 2.414e9
	Radius 6.96e6
}

Galaxy "#A963"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A963"
	AbsMag  -10.0  	Type "E0"
	RA 10.286
	Dec 39.02
	Distance 2.414e9
	Radius 6.59e6
}

Galaxy "#A854"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A854"
	AbsMag  -10.0  	Type "E0"
	RA 9.701
	Dec 8.94
	Distance 2.423e9
	Radius 5.02e6
}

Galaxy "#A223"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A223"
	AbsMag  -10.0  	Type "E0"
	RA 1.633
	Dec -12.78
	Distance 2.424e9
	Radius 6.87e6
}

Galaxy "#A1571"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1571"
	AbsMag  -10.0  	Type "E0"
	RA 12.545
	Dec 83.34
	Distance 2.445e9
	Radius 7.4e6
}

Galaxy "#A3157"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3157"
	AbsMag  -10.0  	Type "E0"
	RA 3.725
	Dec -29.94
	Distance 2.445e9
	Radius 6.1e6
}

Galaxy "#A1430"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1430"
	AbsMag  -10.0  	Type "E0"
	RA 11.991
	Dec 49.79
	Distance 2.2460e9
	Radius 5.9e6
}

Galaxy "#A222"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A222"
	AbsMag  -10.0  	Type "E0"
	RA 1.624
	Dec -12.98
	Distance 2.466e9
	Radius 6.92e6
}

Galaxy "#A2317"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2317"
	AbsMag  -10.0  	Type "E0"
	RA 19.138
	Dec 69.07
	Distance 2.466e9
	Radius 7.35e6
}

Galaxy "#A3207"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3207"
	AbsMag  -10.0  	Type "E0"
	RA 4.048
	Dec -27.2
	Distance 2.476e9
	Radius 5.48e6
}

Galaxy "#A1304"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1304"
	AbsMag  -10.0  	Type "E0"
	RA 11.546
	Dec 35.46
	Distance 2.487e9
	Radius 5.55e6
}

Galaxy "#A1785"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1785"
	AbsMag  -10.0  	Type "E0"
	RA 13.745
	Dec 38.15
	Distance 2.493e9
	Radius 5.77e6
}

Galaxy "#A1246"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1246"
	AbsMag  -10.0  	Type "E0"
	RA 11.397
	Dec 21.43
	Distance 2.517e9
	Radius 6.62e6
}

Galaxy "#A2003"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2003"
	AbsMag  -10.0  	Type "E0"
	RA 14.978
	Dec 19.45
	Distance 2.53e9
	Radius 4.75e6
}

Galaxy "#A1929"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1929"
	AbsMag  -10.0  	Type "E0"
	RA 14.531
	Dec 29.53
	Distance 2.549e9
	Radius 5.88e6
}

Galaxy "#A1934"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1934"
	AbsMag  -10.0  	Type "E0"
	RA 14.556
	Dec 29.45
	Distance 2.553e9
	Radius 6.72e6
}

Galaxy "#AS230"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS230"
	AbsMag  -10.0  	Type "E0"
	RA 2.198
	Dec -47.85
	Distance 2.555e9
	Radius 2.78e6
}

Galaxy "#A777"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A777"
	AbsMag  -10.0  	Type "E0"
	RA 9.472
	Dec 78.23
	Distance 2.599e9
	Radius 7.65e6
}

Galaxy "#A1942"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1942"
	AbsMag  -10.0  	Type "E0"
	RA 14.643
	Dec 3.67
	Distance 2.599e9
	Radius 6.66e6
}

Galaxy "#A2397"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2397"
	AbsMag  -10.0  	Type "E0"
	RA 21.936
	Dec 1.34
	Distance 2.599e9
	Radius 6.78e6
}

Galaxy "#A3934"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3934"
	AbsMag  -10.0  	Type "E0"
	RA 22.893
	Dec -33.72
	Distance 2.599e9
	Radius 6.23e6
}

Galaxy "#A517"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A517"
	AbsMag  -10.0  	Type "E0"
	RA 4.841
	Dec -9.23
	Distance 2.604e9
	Radius 5.77e6
}

Galaxy "#A1299"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1299"
	AbsMag  -10.0  	Type "E0"
	RA 11.539
	Dec 33.97
	Distance 2.607e9
	Radius 6.06e6
}

Galaxy "#A2246"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2246"
	AbsMag  -10.0  	Type "E0"
	RA 17.012
	Dec 64.21
	Distance 2.61e9
	Radius 6.78e6
}

Galaxy "#A593"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A593"
	AbsMag  -10.0  	Type "E0"
	RA 7.866
	Dec 72.82
	Distance 2.62e9
	Radius 6.9e6
}

Galaxy "#A1093"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1093"
	AbsMag  -10.0  	Type "E0"
	RA 10.782
	Dec 9.07
	Distance 2.62e9
	Radius 4.78e6
}

Galaxy "#AS1151"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1151"
	AbsMag  -10.0  	Type "E0"
	RA 23.805
	Dec -28.91
	Distance 2.62e9
	Radius 7.75e6
}

Galaxy "#A1958"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1958"
	AbsMag  -10.0  	Type "E0"
	RA 14.721
	Dec 30.97
	Distance 2.644e9
	Radius 5.73e6
}

Galaxy "#A2111"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2111"
	AbsMag  -10.0  	Type "E0"
	RA 15.661
	Dec 34.41
	Distance 2.65e9
	Radius 6.81e6
}

Galaxy "#Abell 141"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 141"
	AbsMag  -10.0  	Type "E0"
	RA 1.092
	Dec -24.65
	Distance 2.661e9
	Radius 4.71e6
}

Galaxy "#Abell 2509"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2509"
	AbsMag  -10.0  	Type "E0"
	RA 22.965
	Dec -21.75
	Distance 2.667e9
	Radius 5.07e6
}

Galaxy "#A1292"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1292"
	AbsMag  -10.0  	Type "E0"
	RA 11.529
	Dec 35.82
	Distance 2.68e9
	Radius 6.06e6
}

Galaxy "#A1533"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1533"
	AbsMag  -10.0  	Type "E0"
	RA 12.409
	Dec 0.91
	Distance 2.68e9
	Radius 6.34e6
}

Galaxy "#A1961"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1961"
	AbsMag  -10.0  	Type "E0"
	RA 14.742
	Dec 31.19
	Distance 2.681e9
	Radius 6.64e6
}

Galaxy "#A3665"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A3665"
	AbsMag  -10.0  	Type "E0"
	RA 20.164
	Dec -53.17
	Distance 2.731e9
	Radius 6.35e6
}

Galaxy "#A2270"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2270"
	AbsMag  -10.0  	Type "E0"
	RA 17.455
	Dec 55.18
	Distance 2.738e9
	Radius 4.71e6
}

Galaxy "#A2384"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2384"
	AbsMag  -10.0  	Type "E0"
	RA 21.871
	Dec -19.55
	Distance 2.746e9
	Radius 5.07e6
}

Galaxy "#A1957"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1957"
	AbsMag  -10.0  	Type "E0"
	RA 14.719
	Dec 31.21
	Distance 2.772e9
	Radius 7.08e6
}

Galaxy "#A2645"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2645"
	AbsMag  -10.0  	Type "E0"
	RA 23.689
	Dec -9.04
	Distance 2.822e9
	Radius 7.59e6
}

Galaxy "#A2125"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2125"
	AbsMag  -10.0  	Type "E0"
	RA 15.683
	Dec 66.31
	Distance 2.827e9
	Radius 7.89e6
}

Galaxy "#A1952"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1952"
	AbsMag  -10.0  	Type "E0"
	RA 14.685
	Dec 28.64
	Distance 2.842e9
	Radius 6.11e6
}

Galaxy "#A1997"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1997"
	AbsMag  -10.0  	Type "E0"
	RA 14.931
	Dec 20.07
	Distance 2.86e9
	Radius 4.25e6
}

Galaxy "#A1550"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1550"
	AbsMag  -10.0  	Type "E0"
	RA 12.487
	Dec 47.71
	Distance 2.901e9
	Radius 7.09e6
}

Galaxy "#A1878"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1878"
	AbsMag  -10.0  	Type "E0"
	RA 14.214
	Dec 29.22
	Distance 2.901e9
	Radius 4.93e6
}

Galaxy "#A1525"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1525"
	AbsMag  -10.0  	Type "E0"
	RA 12.368
	Dec -1.14
	Distance 2.95e9
	Radius 7.35e6
}

Galaxy "#A1178"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1178"
	AbsMag  -10.0  	Type "E0"
	RA 11.164
	Dec 34.6
	Distance 2.956e9
	Radius 6.04e6
}

Galaxy "#A348"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A348"
	AbsMag  -10.0  	Type "E0"
	RA 2.399
	Dec -8.59
	Distance 3.096e9
	Radius 4.84e6
}

Galaxy "#A41"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A41"
	AbsMag  -10.0  	Type "E0"
	RA 0.48
	Dec 7.84
	Distance 3.106e9
	Radius 6.89e6
}

Galaxy "#A1758"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1758"
	AbsMag  -10.0  	Type "E0"
	RA 13.542
	Dec 50.51
	Distance 3.154e9
	Radius 7.51e6
}

Galaxy "#A1622"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1622"
	AbsMag  -10.0  	Type "E0"
	RA 12.827
	Dec 49.83
	Distance 3.207e9
	Radius 5.9e6
}

Galaxy "#A528"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A528"
	AbsMag  -10.0  	Type "E0"
	RA 4.988
	Dec -9.01
	Distance 3.246e9
	Radius 4.41e6
}

Galaxy "#A1224"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1224"
	AbsMag  -10.0  	Type "E0"
	RA 11.349
	Dec 36.43
	Distance 3.247e9
	Radius 5.1e6
}

Galaxy "#A639"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A639"
	AbsMag  -10.0  	Type "E0"
	RA 8.332
	Dec 67.91
	Distance 3.259e9
	Radius 6.61e6
}

Galaxy "#A1018"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A1018"
	AbsMag  -10.0  	Type "E0"
	RA 10.465
	Dec 17.56
	Distance 3.316e9
	Radius 4.75e6
}

Galaxy "#A2744"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2744"
	AbsMag  -10.0  	Type "E0"
	RA 0.239
	Dec -30.39
	Distance 3.418e9
	Radius 6.64e6
}

Galaxy "#AS910"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS910"
	AbsMag  -10.0  	Type "E0"
	RA 20.956
	Dec -64.66
	Distance 3.446e9
	Radius 6.56e6
}

Galaxy "#AS1077"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=AS1077"
	AbsMag  -10.0  	Type "E0"
	RA 22.981
	Dec -34.78
	Distance 3.455e9
	Radius 5.81e6
}

Galaxy "#Abell 2444"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=Abell 2444"
	AbsMag  -10.0  	Type "E0"
	RA 22.463
	Dec -23.83
	Distance 3.565e9
	Radius 4.84e6
}

Galaxy "#A2084"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A2084"
	AbsMag  -10.0  	Type "E0"
	RA 15.502
	Dec 35.3
	Distance 3.728e9
	Radius 4.96e6
}

Galaxy "#A895"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A895"
	AbsMag  -10.0  	Type "E0"
	RA 9.946
	Dec 49.5
	Distance 3.887e9
	Radius 4.84e6
}

Galaxy "#A370"
{
	InfoURL "http://simbad.u-strasbg.fr/sim-id.pl?Ident=A370"
	AbsMag  -10.0  	Type "E0"
	RA 2.664
	Dec -1.59
	Distance 3.999e9
	Radius 4.41e6
}
